/*
* Programm fr HE_KASSE.prg
* 
* Ideen: KAssenmodul fr HERMES
* Autor: Hans Krasser
*/

*******************************************************************************
*
* DUMMY-Funktionen fr Test
*-------------------------------------------------------------------------------
function LAB_COL_TEST()
    * Wenn ein Gruppen-Button geklickt wird, markiert den darunter liegenden
    * Label grn, alle anderen grau    
    LOCAL cFocus:=UPPER( Main.FocusedControl )
    LOCAL i, ci,cProf:=" ", CN:=LN:=" "    
  

    *MsgInfo(" Fokus button "+cFocus)   
    *Main.Lab_Grp_02.BACKCOLOR:={0,208,0}
    
    FOR i:=1 to 10  
        ci:= STRZERO(i ,2)
        CN := "BUT_GRP_"+ ci
        LN := "LAB_GRP_"+ ci
        IF CN = cFocus
            SetProperty ("Main",LN ,"BACKCOLOR", {0,208,0}  )
        Else
            SetProperty ("Main",LN ,"BACKCOLOR", {175,175,177}  )        
        EndIF
    Next i    

Return .F.
*------------------------------------------------------------------------------
function BEST_SAVE()
    MsgInfo(" BEST_SAVE() " )
Return .F.

*------------------------------------------------------------------------------
function BEST_ESC()
    MsgInfo(" BEST_SAVE() " )
Return .F.

*------------------------------------------------------------------------------
function BEST_ANZAHL(cText)
    MsgInfo(" BEST_ANZAHL() "+cText )
Return .F.


*************************************************
*   SCANNEN                                     *
*------------------------------------------------
function Art_ScanB()
    * Wenn das Feld "Text_44" mit ENTER verlassen wird, also auch beim Scannen
    * wird eine neue Position zum bestehenden Vorgang angelegt
    LOCAL cSuchStr1:=ALLTRIM(Main.Text_44.Value)
    LOCAL lnurZahl:=.T.,i,cZeichen,nlang:=0
    LOCAL cNull:="0000000000000",cPZN6:=cPZ_PZN:=" "
    *MsgInfo("ENTER von Text_44")
    * Verteilung je nachdem, welcher Code aktiv  -cVorg_Code ist PRIVATE 

    *IF !lNeue_Daten     &&..........................................
     *   MsgStop("alte Vorgnge knnen nicht mehr bearbeitet werden")
     *   RETURN
    *ENDIF               &&.......................................... 
        
    FOR i:=1 to LEN(cSuchStr1)
        IF !substr(cSuchStr1,i,1) $ "0123456789"
            lnurZahl:=.F.
        ENDIF 
    NEXT i    
    * .........................................................
    * Unterscheidung: EAN, Suche nach Artikelnummer
    * .........................................................        
    IF lnurZahl
        nlang:=LEN(cSuchStr1)
        DO CASE       
            case nlang = 13           
                * hier wird nur EAN gesucht, keine Zerlegung in Art.Nr !            
                Ad_Item_B(cSuchStr1) 
            case nlang <= 9  
                * hier wird nach einer Artikelnummer gesucht
                IF nlang < 7
                    cSuchStr1:=substr(cNull,1 , 7-nlang)+cSuchStr1
                    Ad_Item_B(cSuchStr1)                     
                EndIf                             
        ENDCASE    
    ELSE
        MsgStop("Unzulssige Eingabe, erlaubt sind nur:"+_CRLF+;
            " - EAN13 mit Scanner"+_CRLF+;
            " - Artikelnummer (max. 9 Stellen)")       
    ENDIF 
    Main.Spinner_1.Value:=1 
    Main.Text_44.Value:=""   
    Main.Text_44.SetFocus              
Return Nil
*------------------------------------------------
function Ad_Item_B(cSuchStr1)
    * Test fr GRID OHNE verkettete DB
    *     1      2     3         4     5    6       7        8       9      10        11       12   13   14 
    * { {'CODE','POS','ART_NUM','BEZ1' ,0   ,0      ,0       ,0    ,'LIEF', 0  ,      0 ,     'LNR','Z','BEZ2'} } 
    * { 'CODE','POS', 'ART_NUM','BEZ1','ANZ','PREIS','RABATT','MWST','LIEF','NTTO_G','MWSt_G','LNR','Z','BEZ1'}
      
    
    LOCAL aValue := { 0 , 0 },nRow:=nCol:=1 ,aWerte [14]
    Local cArt_Nr:="",lgibtLief:=.F.,nUst_Fakt:=nUst_Proz:=0
         
    SELECT AART
    IF LEN (cSuchStr1) = 13
        set order to 5      && index on EAN  to (cm_Pfad_DBF+"AART_EAN")    
    Else
        set order to 1      && index on EDVNR  to (cm_Pfad_DBF+"AART")    
    Endif
    
    seek cSuchStr1
    IF found()
      IF upper(aart->LISTKZ) = "J" 
        cArt_Nr:=alltrim(aart->EDVNR)   && hat Lnge 9 !!
        select ALIA
        set order to 3  && index on EDVNR+P_VERGL
        seek cArt_Nr
        IF found()      && oben steht der billigste Anbieter
    
            IF .T.      && lgibtLief
                aWerte [1]:=cVorg_Code 
                aWerte [2]:=STRZERO(Main.Grid_1.ItemCount+1, 2)
                IF Main.Grid_1.ItemCount+1 > 999
                   MsgStop("Es sind maximal 999 Positionen mglich")
                   RETURN           
                ENDIF 
                aWerte [3]:=cArt_Nr     && interne Artikelnummer der Ordi ####
                aWerte [4]:=rtrim(aart->Bez1)+" /"+AART->MEVK
                aWerte [5]:=Main.Spinner_1.Value  && Spinner_1 wird von IDE 2.9 nur >0 implem => hnd. nderung FMG !!!
                
                IF AART->MWST $ "123" 
                    nUst_Proz:=USt_Satz[ val(AART->MWST) ]
                    nUst_Fakt:=1+nUst_Proz /100  
                    aWerte [6]:=AART->VKP1            && aart->VK1  = Brutto-VKpreis
                    IF aWerte [6] = 0
                      MsgStop("Fr den Artikel "+cArt_Nr+" "+rtrim(aart->Bez1)+c_CR_LF+;
                        "ist kein glter VK-Preis gespeichert. (DB: AART->VKP1)")
                      RETURN
                    * Abbruch, da kein korrekter Preis berechnet werden kann                       
                    EndIF               
                Else
                    MsgStop("Fr den Artikel "+cArt_Nr+" "+rtrim(aart->Bez1)+c_CR_LF+;
                      "ist kein glter MWSt-Satz gespeichert. (DB: AART->MWST)")
                    RETURN
                    * Abbruch, da kein korrekter Preis berechnet werden kann               
                Endif
                
                aWerte [7]:=aWerte [6]* aWerte [5]      && aart->VK1 (Brutto-VKpreis) * STK  
                aWerte [8]:=-0.50 * aWerte [5]          && Rabatt fehlt noch 
                aWerte [9]:=aWerte [7] +aWerte [8]      && VKP_GES-R 8.3 VKP brutto der Gesamtmenge - Rabatt
                aWerte [10]:=nUst_Proz                  && MWST_PROZ N 5.2 MWST in Prozent
                aWerte [11]:=aWerte [9] - aWerte [9]/nUst_Fakt && MWST_GES  N 10.2 Mehrwertsteuer in EUR                  
                                                        && (= VKP_BTTO - VKP_NTTO)  
                aWerte [12]:=AART->MWST                 && C 1.0 Mehrwersteuer-Code
                aWerte [13]:=space(1)                  && Z1        C  1.0
                aWerte [14]:=rtrim(aart->Bez2)   && BEZ2      C 500Bezeichnung 2 
        
                * ev. Mengenkorrektur ? / Wie Lschen implementieren ?
                Main.Grid_1.AddItem(aWerte)
                *nRow :=Main.Grid_1.ItemCount
                *Main.Grid_1.Value:={ nRow , nCol }          
                Main.Grid_1.Refresh
                Main.Button_2.Visible := .T.
                Main.Button_3.Visible := .T.   
                Main.Button_8.Visible := .T.
                Main.Button_9.Visible := .T.
            Else
                MsgStop("Fr den Artikel Nr. "+ cArt_Nr+" gibt es derzeit KEINEN Lieferanten","Datenbank ALIA")              
            Endif
          
        Else    && 202
            MsgStop("Fr den Artikel Nr. "+ cArt_Nr+" gibt es derzeit KEINEN Lieferanten","Datenbank ALIA")          
        Endif   && 202
          
      Else  && 197
        MsgStop("Artikel "+ cSuchStr1+" ist derzeit NICHT AKTIV","Datenbank AART")         
      Endif && 197                                                                          
    ELSE    && 196
        MsgStop("Artikel "+ cSuchStr1+" nicht gefunden","Datenbank AART")   
    ENDIF   && 196
      
Return Nil
