/*
* Programm HE_LIEF.PRG
* 
* Ideen: Lieferantenverwaltung
* Autor: Hans Krasser
*/



******************************************************************************
*    SCHIRM SC_LIEF1
*------------------------------------------------------------------------------
procedure DI_SC_LIEF1()
    LOCAL i:=0,ci
    PRIVATE l_neueDaten:=.F.

    IF IsWindowActive(SC_LIEF1)
        RELEASE WINDOW SC_LIEF1
    ENDIF
    Load Window SC_LIEF1


    *Variablenlisten fr IDE fehlen ###-------------

    * Laden des DB Felder in den Schirm-------------
    LO_SC_LIEF1()

    Activate Window SC_LIEF1
return

*------------------------------------------------------------------------------
procedure LO_SC_LIEF1()
 *ladet Variablen aus der Datei in den Schirm
    LOCAL i:=0,ci,cText
    
    SC_LIEF1.Button_1.show   
    SC_LIEF1.Button_2.show   
    SC_LIEF1.Button_3.show   
    SC_LIEF1.Button_4.show   
    SC_LIEF1.Button_5.show   

    SC_LIEF1.Button_7.hide  
    SC_LIEF1.Button_8.hide 
    	
    SELECT ALI1
	FOR i:=1 TO FCOUNT()
      ci:= IIF( i <10, STR(i ,1),STR(i ,2) )
      DO CASE
          CASE ci $ ",,"
	           * Bei anderen Properties als Text
          OTHERWISE
            cText:="Text_" + ci
            SetProperty ("SC_LIEF1",cText ,"Value", FIELDGET( i ) )
      ENDCASE
	NEXT i
	SC_LIEF1.Text_34.BackColor:=IIF(SC_LIEF1.Text_34.Value="J",{255,255,255},{255,0,0} )

return

*------------------------------------------------------------------------------
procedure S1_SC_LIEF1(lSpeichern,lNew)
    * kommt  entweder von BUTTON_7/Speichern oder BUTTON_8/Abbruch
    IF lSpeichern
        SA_SC_LIEF1(lNew)   && lNew bei Add .T., bei Modify .F.
    ENDIF
    LO_SC_LIEF1()           && stellt wieder alle buttons dar ausser 7+8
return
*------------------------------------------------------------------------------
procedure SA_SC_LIEF1(lNew)
 * speichert Variablen aus dem Schirm in die Datei
    LOCAL i:=0,nVar_Beg:=2,ci,cText
	
    SELECT ALI1
    IF lNew
	    nVar_Beg:=1
      * stimmt nur, wenn NUR FIELD(1) = Key !!!
      dbAppend()
      IF NETERR()
          MsgInfo( "Derzeit ist die Datei gesperrt, Anfgen von Daten nicht mglich")
          return
      ENDIF
    ENDIF
    IF RLOCK()
	    FOR i:=nVar_Beg TO FCOUNT()
          ci:= IIF( i <10, STR(i ,1),STR(i ,2) )
          DO CASE
              CASE ci $ ",,"
	               * Bei anderen Properties als Text
              OTHERWISE
                cText:="Text_" + ci
                FieldPut( i, GetProperty ("SC_LIEF1",cText ,"Value" ) )
          ENDCASE
	    NEXT i
      UNLOCK
    ELSE
      MsgInfo( "Derzeit ist der Datensatz gesperrt, nderungen nicht mglich")
      return
    ENDIF

return

*-----------------------------------------------------------------------------
function SK_SC_LIEF1(nSaetze)
    LOCAL nRecord_No:= recno(),lSatz_bewegt:=.F.
    
    SC_LIEF1.Label_3.Value:=""    
    IF nSaetze >= 0
        IF eof()
            SC_LIEF1.Label_3.Value:="letzter Satz"  
            PlayHand()          && hier kann nicht zu nRecord_No springen
        ELSE
            skip nSaetze
            if eof()
                SC_LIEF1.Label_3.Value:="letzter Satz"
                PlayHand()
                go nRecord_No
            else
                lSatz_bewegt:=.T.
            endif
        ENDIF
    
    ELSE
        IF bof()
            SC_LIEF1.Label_3.Value:="erster Satz"        
            PlayHand()          && hier kann nicht zu nRecord_No springen
        ELSE
            skip nSaetze
            if bof()
                SC_LIEF1.Label_3.Value:="erster Satz" 
                PlayHand()
                go nRecord_No
            else
                lSatz_bewegt:=.T.               
            endif
        ENDIF    
    ENDIF
    
    IF lSatz_bewegt
        LO_SC_LIEF1()
    endif
    
return Nil

*-----------------------------------------------------------------------------
function AD_SC_LIEF1(lNew)
    * neue Daten eingeben
         
    l_neueDaten:=lNew   
    IF lNew
        CL_SC_LIEF1()
    ENDIF 
    SC_LIEF1.Button_1.hide   
    SC_LIEF1.Button_2.hide   
    SC_LIEF1.Button_3.hide   
    SC_LIEF1.Button_4.hide   
    SC_LIEF1.Button_5.hide   

    SC_LIEF1.Button_7.show   
    SC_LIEF1.Button_8.show   

return Nil
*-----------------------------------------------------------------------------
function CL_SC_LIEF1()
    * lschte Alles Datenfelder vor einer neuen Eingabe
    *  Falls neue DB-Felder definiert werden, fllt durch Fehlermeldung auf wenn Textfeld fehlt    
    LOCAL i,ci,cText:="",nLast_Edv:=0,nRecord_No:=recno(),l_is_Eof:=eof()
        
	FOR i:=1 TO FCOUNT()
       ci:= IIF( i <10, STR(i ,1),STR(i ,2) )
       cText:="Text_" + ci       
       DO CASE
          CASE valtype( FIELDGET( i ) ) = "N"
              SetProperty ("SC_LIEF1",cText ,"Value", 0 )
          CASE valtype( FIELDGET( i ) ) = "C"
              SetProperty ("SC_LIEF1",cText ,"Value", space(1) )
       ENDCASE
	NEXT i
	
	set order to 1
	go bottom
	nLast_Edv:= val(ALI1->LNR)
	IF !l_is_Eof
	   go nRecord_No
	ENDIF
	SC_LIEF1.Text_1.value:=STRZERO(nLast_Edv+1, 6, 0)
return Nil
*-----------------------------------------------------------------------------
function FI_SC_LIEF1()
    LOCAL nRecordNo

    
    SELECT ALI1 
    set order to 2            && 2:index on UPPER(MC)  to  (cm_Pfad_DBF+"ALI1_MC")
    nRecordNo:=recno()

    IF IsWindowActive(FI_SC_LIEF1)
	   RELEASE WINDOW FI_SC_LIEF1
    ENDIF
    
	DEFINE WINDOW FI_SC_LIEF1 ;
		AT 0,0 ;
		WIDTH 900 ;
		HEIGHT 440 ;
		TITLE 'Suche nach Lieferanten...  Doppelclick zur Auswahl' ;
		NOSYSMENU;
		CHILD
		
        @0,0 BROWSE BROWSE_LIEF1 ;
        WIDTH 880 ;
        HEIGHT 400 ;
        HEADERS { 'LNR' , 'MC' , 'NAME' , 'BRA' , 'STR' , 'PLZ' , 'ORT' , 'STKZ' , 'TELEFON' , 'EMAIL' , 'FAX' , 'GF' , 'VKL' , 'SB' , 'BEST_ARTC' , 'BEST_ARTT' , 'ERSTKO3' , 'ZART1' , 'ZART2' , 'ZART3' , 'FBEZ1' , 'FBEZ2' , 'FBEZ3' , 'LART1' , 'LART2' , 'WC' , 'MBESTWERT' , 'FREHAUS_AB' , 'LLIST_Z'} ;
        WIDTHS {  90, 64,240,100,70, 40,100, 2,160,240,160,240,240,240, 16,160,240,240,240,240,240,240,240,240,240, 24, 100,100,  8} ;
        WORKAREA ALI1 ;
        FIELDS { 'ALI1->LNR' , 'ALI1->MC' , 'ALI1->NAME' , 'ALI1->BRA' , 'ALI1->STR' , 'ALI1->PLZ' , 'ALI1->ORT' , 'ALI1->STKZ' , 'ALI1->TELEFON' , 'ALI1->EMAIL' , 'ALI1->FAX' , 'ALI1->GF' , 'ALI1->VKL' , 'ALI1->SB' , 'ALI1->BEST_ARTC' , 'ALI1->BEST_ARTT' , 'ALI1->ERSTKO3' , 'ALI1->ZART1' , 'ALI1->ZART2' , 'ALI1->ZART3' , 'ALI1->FBEZ1' , 'ALI1->FBEZ2' , 'ALI1->FBEZ3' , 'ALI1->LART1' , 'ALI1->LART2' , 'ALI1->WC' , 'ALI1->MBESTWERT' , 'ALI1->FREHAUS_AB' , 'ALI1->LLIST_Z'} ;
		TOOLTIP "Bitte Doppelclick zur Auswahl" ;
		ON DBLCLICK SUCHE_L1_0()
				
        FI_SC_LIEF1.BROWSE_LIEF1.Value := recno()

	END WINDOW

	CENTER WINDOW FI_SC_LIEF1

	ACTIVATE WINDOW FI_SC_LIEF1

Return Nil

*-----------------------------------------------------------------------------
function SUCHE_L1_0()
    * beendet die Suchfunktion und kehrt zu Lieferantenschirm zurck

    RELEASE WINDOW FI_SC_LIEF1 
    SC_LIEF1.SetFocus
    SC_LIEF1.Label_3.Value:=""     
    LO_SC_LIEF1()          && ladet die Variablen in die Textfelder
Return Nil

******************************************************************************
*   ENDE SCHIRM SC_LIEF1
*------------------------------------------------------------------------------
procedure CLOSE_LIEF1()
    Release Window SC_LIEF1
return
