/*
* Programm fr Artikel- und Auftragsverwaltung
* Ideen: Datenstrukturen von ALI1, ALIA u AART bernommen und  ergnzt 
* Autor: Hans Krasser
*/

#include "minigui.ch"
#include "Fileio.ch"
#include <hmg.ch>
* Konstanten fr leichteres ansprechen der low-level Funktionen
#define _FNAME         1
#define FO_SHARED      64

*    System.clipboard := "Das ist ein Test fr die Funktion System.clipboard :="
Function Main
    LOCAL z:=s:=0,cz:=cs:=cBut_Nr:="",nBut_Nr:=1
    LOCAL nZeil_Hoch:=70,lUnderline:=.F.
    LOCAL cEdvNr:=""
    Local aC1:= {'TEXTBOX','CHARACTER'}
    Local aC2:= {'TEXTBOX','CHARACTER'}
    Local aC3:= {'TEXTBOX','CHARACTER'}
    Local aC4:= {'TEXTBOX','CHARACTER'}    
    Local aC5:= {'TEXTBOX','NUMERIC','9999'}        && STK
    Local aC6:= {'TEXTBOX','NUMERIC','99999.99'}    && VKP_BTTO  8.3 VKP brutto der Verkaufseinheit
    Local aC7:= {'TEXTBOX','NUMERIC','99999.99'}    && VKP_GES   8.3 VKP brutto der Gesamtmenge
    Local aC8:= {'TEXTBOX','NUMERIC','99999.99'}    && RABATT    8.3 Abzug in EUR    
    Local aC9:= {'TEXTBOX','NUMERIC','99999.99'}    && VKP_GES-R 8.3 VKP brutto der Gesamtmenge - Rabatt
    Local aC10:= {'TEXTBOX','NUMERIC','999.99'}     && MWST_PROZ N 5.2 MWST in Prozent
    Local aC11:= {'TEXTBOX','NUMERIC','99999.99'}   && MWST_GES  N 10.2 Mehrwertsteuer in EUR   
    Local aC12:= {'TEXTBOX','CHARACTER'}            && MWST      C  1.0 Mehrwertsteuer-Code 
    Local aC13:= {'TEXTBOX','CHARACTER'}            && Z1        C  10  
    Local aC14:= {'TEXTBOX','CHARACTER'}            && BEZ2      C 500Bezeichnung 2           
    * {aC1,aC2,aC3,aC4,aC5,aC6,aC7,aC8,aC9,aC10,aC11,aC12,aC13,aC14}
    * 
    *     1      2     3         4     5    6       7        8       9      10        11       12   13   14 
    * { {'CODE','POS','ART_NUM','BEZ1' ,0   ,0      ,0       ,0    ,'LIEF', 0  ,      0 ,     'LNR','Z','BEZ2'} } 
    * { 'CODE','POS', 'ART_NUM','BEZ1','ANZ','PREIS','RABATT','MWST','LIEF','NTTO_G','MWSt_G','LNR','Z','BEZ1'}
    * { 55, 45, 90, 350, 50,90, 3, 60, 110,90, 80 ,90 ,30 ,350} 
    *   1   2   3    4    5  6   7  8   9   10  11  12  13  14       
              
    *PRIVATE cVorg_Code:= cCode ,cVorg_Txt:=cKlartext 
    PRIVATE cVorg_Code:="BAR", cCode:=cVorg_Txt:=cKlartext:=" "     
    PRIVATE c_CR_LF:=chr(13)+chr(10)
    
   PRIVATE files_ok := .T.
   PRIVATE cm_Pfad_DBF:="",cm_Pfad_Dateien:="",cm_Pfad_Rechte:="       ",cPfadDatei:=""
	PRIVATE Profile[10],Profile_Cap[10],DEVICE_A4:=" ",DEVICE_Etti:=" ",ETTI_COLOR:=" "
	PRIVATE PATH_Gany_Pat:=" ",PATH_INI:=" ",DR_Code:=DR_Name:=DR_Ort:=DR_PLZ:=ETTI_PREV:=" "
	PRIVATE Lab_Spalte[15],lModify:=.F.,lVar1:=.F.
	PRIVATE USt_Satz:={ 20,10, 0},cUSt1:=cUSt2:=cUSt3:=" ",cRichterLnr:=""
 
    REQUEST HB_LANG_DE      // German.
    HB_LANGSELECT( "DE" )
    SET BROWSESYNC ON
    SET DATE GERMAN
    SET DELETED ON
    SET TOOLTIPSTYLE BALLOON     
    
    *AFILL(Profile_Cap, " ")  
    *---------------------------------------------------------------------------
    BEGIN INI FILENAME  "HERMES.INI" 
         FOR i:= 1 TO 15
            ci := STRZERO(i,2)
            GET Lab_Spalte[i] SECTION "PROFILE" ENTRY "LABOR_"+ci DEFAULT " "                                   
        NEXT i                
        GET DEVICE_Etti SECTION "PRINTER" ENTRY "DEVICE_Etti" DEFAULT "  "
        GET ETTI_COLOR SECTION "PRINTER" ENTRY "ETTI_COLOR" DEFAULT "JA" 
        GET ETTI_PREV SECTION "PRINTER" ENTRY "ETTI_PREV" DEFAULT "NEIN"                        
        GET cm_Pfad_Dateien SECTION "PFADE" ENTRY "PATH_Dateien" DEFAULT " "
                     
        FOR i:= 1 TO 10
            ci := IIF(i < 10, "0"+STR(i,1), STR(i,2) )
            GET Profile_Cap[i] SECTION "PROFILE" ENTRY "PROFIL_"+ci DEFAULT " "          
            GET Profile[i] SECTION "PROFILE" ENTRY "P_"+ci DEFAULT " " 
               
        NEXT i 
        GET cUSt1 SECTION "PROFILE" ENTRY "PROFIL_01" DEFAULT "20"
        GET cUSt2 SECTION "PROFILE" ENTRY "PROFIL_02" DEFAULT "0"
        GET cUSt3 SECTION "PROFILE" ENTRY "PROFIL_03" DEFAULT "0" 
        GET cRichterLnr SECTION "PROFILE" ENTRY "RICHTERLIEF" DEFAULT "000815"              
        GET DR_Code SECTION "ARZT" ENTRY "ARZT_CODE" DEFAULT "AH"                                
        GET DR_Name SECTION "ARZT" ENTRY "ARZT_NAME" DEFAULT "  " 
        GET DR_Ort  SECTION "ARZT"  ENTRY "ARZT_ORT" DEFAULT "  " 
        GET DR_PLZ  SECTION "ARZT" ENTRY "ARZT_PLZ" DEFAULT "  " 
                                           
    END INI 
    * In HERMES.INI wird PROFIL_01 - 03 fr MWSt-Satz als String verwendet 
    USt_Satz[1]:= val(cUSt1)
    USt_Satz[2]:= val(cUSt2)
    USt_Satz[3]:= val(cUSt3)  
    FOR i:= 1 TO 3
        *MsgInfo("Typ von USt_Satz["+str(i,1)+" ] "+valtype(USt_Satz[i])+ str(USt_Satz[i],5)  )
    NEXT i  
   
    cm_Pfad_DBF:=cm_Pfad_Dateien   
    SET PATH TO ( LTRIM(cm_Pfad_DBF) )

    if !FILS_OK_B()
     MsgStop( 'Programm wird beendet' )
      RETURN
   endif
    OpenTablesB()     
    IF IsWindowActive(Main)
        RELEASE WINDOW Main
    ENDIF 
      
    SET TOOLTIPSTYLE BALLOON    
   DEFINE WINDOW Main ;
      AT 50,70 ;
      WIDTH 1150 ;
      HEIGHT 930 ;
      MAIN;
      TITLE 'HERMES'

      DEFINE MAIN MENU
 			POPUP 'Datei     '
				ITEM 'ENDE Programm'        ACTION CloseTables()            				
			END POPUP
 			POPUP 'Lieferanten     '
				ITEM 'Stammdaten'           ACTION DI_SC_LIEF1()            				
			END POPUP
 			POPUP 'Artikel     '
				ITEM 'Artikelstamm'         ACTION DI_SC_AART() 
				ITEM 'Artikelgruppen'       ACTION SC_HGUG( , .T.)                           				
			END POPUP
			POPUP 'Drucken     '
				ITEM 'Artikelliste HG-UG'    ACTION ART_LIST1() 
				ITEM 'Fehlerprotokoll-Order' ACTION CHK_ORDER() 
				ITEM 'Artikel OHNE Lagerort' ACTION ART_LIST_LAG0() 
				ITEM 'Orderliste'           ACTION DR_MEDIKA("ORDERLISTE")
				ITEM 'Hilfe Orderliste'     ACTION HLP_ORL1() 
				ITEM 'ALIA: PACK_INH >1'    ACTION REP_ALIA_1()                                                            				
			END POPUP 
 			POPUP 'Wartung     '
				ITEM 'bernahme von Richter-Artikeln'           ACTION WA_RI_PLM()   
				ITEM 'Wartung Preise Richter-Artikel'           ACTION WA_RI_VKP() 
				ITEM 'TEST: Regalettiketten   '                 ACTION DR_Etiketten()                                      				
			END POPUP                       	            			
      END MENU
      FOR s:=1 to 10
            cs:=str(s,1)
            cBut_Nr:=STRZERO(nBut_Nr,2)
            DEFINE BUTTON &("But_Grp_"+cBut_Nr)
                ROW 0 
                COL (s*100)-100 
                CAPTION "Gruppe "+cBut_Nr   && ONCLICK "LAB_COL_TEST( "+cBut_Nr +")"
                ACTION LAB_COL_TEST()
                WIDTH 100 
                HEIGHT nZeil_Hoch-10 
                TOOLTIP "Das ist die lange Gruppen beschreibung von Gruppe"+cBut_Nr
                FONTBOLD .T.
                MULTILINE .T.            
            END BUTTON
                      
            DEFINE LABEL &("Lab_Grp_"+cBut_Nr)
                ROW nZeil_Hoch-8
                COL (s*100)-100 
                VALUE space(1) 
                WIDTH 100
                HEIGHT 6
                BACKCOLOR {175,175,177}
            END LABEL
            
            nBut_Nr++
        NEXT s

      nBut_Nr:=1      
      FOR z:=1 to 4
        cz:=str(z,1)
        FOR s:=1 to 10
            cs:=str(s,1)
            cBut_Nr:=STRZERO(nBut_Nr,2)
            lUnderline:= IIF(cBut_Nr $ "01,09,28,31",.T., .F.)
            DEFINE BUTTON &("Button_"+cBut_Nr)
                ROW 0+z*nZeil_Hoch 
                COL (s*100)-100
                ACTION BUT_VERKAUF()
                CAPTION "Auch Eine ARTIKEL NUMMER"+cBut_Nr 
                WIDTH 100 
                HEIGHT nZeil_Hoch 
                TOOLTIP "9088880533352 Das ist die lange Artikelbeschreibung von Artikel"+cBut_Nr+;
                        "PCK zu 30 STK 11,90 EUR"
                FONTUNDERLINE lUnderline
                MULTILINE .T.            
            END BUTTON
            nBut_Nr++
        NEXT s
      NEXT i
      
      DEFINE LABEL Label_1
        ROW    362
        COL    30
        WIDTH  90
        HEIGHT 30
        VALUE "Bestellung"
        FONTNAME "Arial"
        FONTSIZE 14
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR {0,0,0}
        RIGHTALIGN .T. 
    END LABEL

    DEFINE TEXTBOX Text_1
        ROW    360
        COL    130
        WIDTH  120
        HEIGHT 30
        FONTNAME "Arial"
        FONTSIZE 14
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

    DEFINE TEXTBOX Text_2
        ROW    360
        COL    270
        WIDTH  300
        HEIGHT 30
        FONTNAME "Arial"
        FONTSIZE 14
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

    DEFINE LABEL Label_2
        ROW    362
        COL    590
        WIDTH  70
        HEIGHT 30
        VALUE "Datum"
        FONTNAME "Arial"
        FONTSIZE 14
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        RIGHTALIGN .T. 
    END LABEL

    DEFINE TEXTBOX Text_3
        ROW    360
        COL    680
        WIDTH  120
        HEIGHT 30
        FONTNAME "Arial"
        FONTSIZE 14
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX
    * CAPTION "SPEICHERN"
    * FONTNAME "Arial"
    * FONTSIZE 16    
    DEFINE BUTTON Button_9
        ROW    760
        COL    950
        WIDTH  150
        HEIGHT 80
        PICTURE "but_Herm_Rechn_1.bmp"        
        ACTION BEST_SAVE()
        PICTALIGNMENT Left
        TOOLTIP "Speichert die Artikel und druckt eine Rechnung aus"
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        HELPID Nil
        FLAT .F.
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.

    END BUTTON

    DEFINE BUTTON Button_8
        ROW    710
        COL    950
        WIDTH  150
        HEIGHT 28
        PICTURE "but_Herm_Rechn_2.bmp"
        ACTION BEST_ESC()
        TOOLTIP "verwirft diese Rechnung OHNE Speichern, kein Ausdruck"
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.

    END BUTTON

    DEFINE GRID Grid_1
        ROW    400
        COL     10
        WIDTH  1100
        HEIGHT 280
        ITEMS { {'CODE','POS','ART_NUM','BEZ1' ,0 ,0 ,0 ,0 ,'LIEF', 0 , 0 , 'LNR','Z','BEZ2'} }
        VALUE 0
        WIDTHS { 55, 45, 90, 350, 50,85, 95, 60, 100,80, 85 ,50 ,3 ,350}
        HEADERS { 'CO','PO', 'Art_Num','Bezeichn1','Anz','Btto-E','Btto-Ges','RABATT','BTTO-KAS','MWST%','MWSt_EUR','MW_CO','Z','BEZ2'}
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONDBLCLICK Nil
        ONHEADCLICK Nil
        ONQUERYDATA Nil
        MULTISELECT .F.
        ALLOWEDIT .F.
        VIRTUAL .F.
        DYNAMICBACKCOLOR Nil
        DYNAMICFORECOLOR Nil
        COLUMNWHEN Nil
        COLUMNVALID Nil
        COLUMNCONTROLS {aC1,aC2,aC3,aC4,aC5,aC6,aC7,aC8,aC9,aC10,aC11,aC12,aC13,aC14}
        SHOWHEADERS .T.
        NOLINES .F.
        HELPID Nil
        IMAGE Nil
        JUSTIFY Nil
        ITEMCOUNT Nil
        BACKCOLOR NIL
        FONTCOLOR NIL
    END GRID

    DEFINE LABEL Label_3
        ROW    722
        COL    70
        WIDTH  180
        HEIGHT 24
        VALUE "Artikelnummer"
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        RIGHTALIGN .T. 
    END LABEL

    DEFINE TEXTBOX Text_44
        ROW    720
        COL    270
        WIDTH  200
        HEIGHT 30
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP "Bitte Ean vom Artikel einscannen oder Artikelnummer eingeben!"
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Art_ScanB()
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .F.
        RIGHTALIGN .F.
        BACKCOLOR {170,206,60}
        FONTCOLOR NIL
        INPUTMASK Nil
        FORMAT Nil
        VALUE ""
    END TEXTBOX

    DEFINE SPINNER Spinner_1
        ROW    720
        COL    490
        WIDTH  60
        HEIGHT 30
        RANGEMIN -100
        RANGEMAX 100
        VALUE 1
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP "Stck, Standard = 1, bei Storno z.B. -1 setzen"
        ONCHANGE Main.Text_44.SetFocus
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        WRAP .F.
        READONLY .F.
        INCREMENT 1
        BACKCOLOR {170,206,60}
        FONTCOLOR NIL
    END SPINNER

    DEFINE LABEL Label_4
        ROW    722
        COL    560
        WIDTH  70
        HEIGHT 24
        VALUE "Stck"
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
    END LABEL

    DEFINE TEXTBOX Text_4
        ROW    710
        COL    740
        WIDTH  130
        HEIGHT 24
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        INPUTMASK "9999.99"
        FORMAT Nil
        NUMERIC .T. 
        VALUE 0
    END TEXTBOX

    DEFINE LABEL Label_5
        ROW    710
        COL    610
        WIDTH  120
        HEIGHT 24
        VALUE "Summe Netto"
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        RIGHTALIGN .T. 
    END LABEL

    DEFINE TEXTBOX Text_5
        ROW    740
        COL    740
        WIDTH  130
        HEIGHT 24
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP ""
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        INPUTMASK "9999.99"
        FORMAT Nil
        NUMERIC .T. 
        VALUE 0
    END TEXTBOX

    DEFINE LABEL Label_6
        ROW    740
        COL    660
        WIDTH  70
        HEIGHT 24
        VALUE "MWSt."
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        RIGHTALIGN .T. 
    END LABEL

    DEFINE TEXTBOX Text_6
        ROW    780
        COL    740
        WIDTH  130
        HEIGHT 40
        FONTNAME "Arial"
        FONTSIZE 20
        TOOLTIP "Gesamtsumme zu bezahlen"
        ONCHANGE Nil
        ONGOTFOCUS Nil
        ONLOSTFOCUS Nil
        FONTBOLD .T.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        ONENTER Nil
        HELPID Nil
        TABSTOP .T.
        VISIBLE .T.
        READONLY .T.
        RIGHTALIGN .F.
        BACKCOLOR Nil
        INPUTMASK "99999.99"
        FORMAT Nil
        NUMERIC .T. 
        VALUE 0
    END TEXTBOX

    DEFINE LABEL Label_7
        ROW    780
        COL    630
        WIDTH  90
        HEIGHT 40
        VALUE "Gesamt"
        FONTNAME "Arial"
        FONTSIZE 20
        TOOLTIP ""
        FONTBOLD .F.
        FONTITALIC .F.
        FONTUNDERLINE .F.
        FONTSTRIKEOUT .F.
        HELPID Nil
        VISIBLE .T.
        TRANSPARENT .F.
        ACTION Nil
        AUTOSIZE .F.
        BACKCOLOR NIL
        FONTCOLOR NIL
        RIGHTALIGN .T. 
    END LABEL

    DEFINE BUTTON Button_2
        ROW    760
        COL    270
        WIDTH  200
        HEIGHT 28
        PICTURE "but_Herm_Rechn_3_Stk.bmp"
        ACTION BEST_ANZAHL("ZAHL")
        TOOLTIP "nderung der Anzahl des markierten Artikels"
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.

    END BUTTON

    DEFINE BUTTON Button_3
        ROW    800
        COL    270
        WIDTH  200
        HEIGHT 28
        PICTURE "but_Herm_Rechn_4_Del.bmp"
        ACTION BEST_ANZAHL("LSCHEN")
        TOOLTIP "storniert den markierten Artikel"
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.

    END BUTTON
    
    DEFINE BUTTON Button_0
        ROW    760
        COL     20
        WIDTH  150
        HEIGHT 80
        PICTURE "but_Herm_Rechn_E.bmp"
        ACTION CloseTables()
        TOOLTIP "Beendet das Kassenprogramm"
        TABSTOP .T.
        VISIBLE .T.
        TRANSPARENT .F.

    END BUTTON    

   END WINDOW
    *============================================================
      select AART       && Buttons mit Artikeln, die keinen EAN Haben
      go top
      nBut_Nr=1
      Do While !eof()
        *IF AART->VKP1 > 0 .and. upper(AART->LISTKZ) = "J".and.upper(AART->EAN_DRUCK) = "J"      
            IF nBut_Nr <= 40        && nur so lange Buttons frei sind       
                cBut_Nr:=STRZERO(nBut_Nr,2)
                SetProperty ("Main","Button_"+cBut_Nr ,"TOOLTIP",;
                AART->EDVNR+" "+rtrim(AART->BEZ1)+" "+rtrim(AART->BEZ2)+" "+str(AART->VKP1,7,2)+" .-- EUR"   )
                IF EMPTY(aart->BEZK) 
                    SetProperty ("Main","Button_"+cBut_Nr ,"CAPTION",;
                    AART->EDVNR+" "+rtrim(AART->BEZ1)   )
                Else
                    SetProperty ("Main","Button_"+cBut_Nr ,"CAPTION",;
                    AART->EDVNR+" "+rtrim(aart->BEZK)+" "+str(AART->VKP1,7,2)+" .-"   )                
                EndIf
                nBut_Nr++                
            EndIf       
        *EndIf
      
        skip
      Enddo  
      go top    
    
    *============================================================    
   *CENTER WINDOW Main
   Main.Grid_1.DeleteItem ( 1)     && was bei alten Vorgngen ??
   Main.Button_2.Visible := .f.
   Main.Button_3.Visible := .f.   
   Main.Button_8.Visible := .f.
   Main.Button_9.Visible := .f.
   ACTIVATE WINDOW Main
Return
*------------------------------------------------
function DUMMY()
return nil
*-------------------------------------------------------------------------------
function BUT_VERKAUF()
    * Wenn ein Verkaufs-Button geklickt wird, sucht den Namen des Button
    * Label grn, alle anderen grau    
    LOCAL cFocus:=UPPER( Main.FocusedControl )

    MsgInfo(" Fokus button "+cFocus+c_CR_LF+;
      GetProperty ("Main",cFocus ,"TOOLTIP" );
      )  
    

Return .F.


Procedure CloseTables()
    RELEASE WINDOW Main
    close all
    QUIT
Return Nil
*------------------------------------------------
function DDDD_MMTT(cJJJJMMTT)
    LOCAL cTTMMJJ:=" "
    
    cTTMMJJ:=substr(cJJJJMMTT,7,2)+"."+substr(cJJJJMMTT,5,2)+"."+substr(cJJJJMMTT,1,4)
Return cTTMMJJ
*-----------------------------------------------------------------------------
function TXT_VALID(aValid_Items,cSchirm,cFeld)
    * prft die Eingaben aus  TEXTFELDERN

    LOCAL nItem:=0,cEingabe:=GetProperty (cSchirm, cFeld ,"Value" )
 
 	nItem:=ASCAN(aValid_Items, { |x| UPPER(x) == UPPER( rtrim(cEingabe) )  })
	IF nItem > 0       && ...Benutzer hat einen gltigen Code eingegeben....
	   SetProperty (cSchirm, cFeld ,"Value", UPPER( cEingabe )  )
	   RETURN           
	ENDIF
	
    IF IsWindowActive(TXT_VALID)    && ...... KEIN gltiger Code ............
        RELEASE WINDOW TXT_VALID
    ENDIF
       
	DEFINE WINDOW TXT_VALID ;
		AT 0,0 ;
		WIDTH 400 ;
		HEIGHT 400 ;
		TITLE 'folgende Eingaben mglich: (+ EINGABETASTE)' ;
		CHILD 

		DEFINE MAIN MENU
			DEFINE POPUP '&Test'
				MENUITEM 'Item Content 1' ACTION MsgInfo ( TXT_VALID.Combo_1.Item (1) )
				MENUITEM 'DisplayValue' ACTION MsgInfo ( TXT_VALID.Combo_1.DisplayValue )
				MENUITEM 'Get Value' ACTION MsgInfo(Str(TXT_VALID.Combo_1.Value))
				MENUITEM 'Set Value' ACTION TXT_VALID.Combo_1.Value := 2
				MENUITEM 'Get DisplayValue' ACTION MsgInfo( TXT_VALID.Combo_1.DisplayValue )
				MENUITEM 'Set DisplayValue' ACTION TXT_VALID.Combo_1.DisplayValue := 'New Text' 
				MENUITEM 'Set Item' ACTION TXT_VALID.Combo_1.Item (3) := 'New Text' 
				MENUITEM 'Get Item' ACTION MsgInfo ( TXT_VALID.Combo_1.Item (3) )		
			END POPUP
		END MENU

		@ 10,10 COMBOBOX Combo_1 ;
			WIDTH 100 ;
			ITEMS aValid_Items ;
			VALUE 1 ;
			ON ENTER END_VALID(cSchirm,cFeld);
			FONT 'Courier' SIZE 12 
			
		@ 220,10 LABEL Label_1 ;
			WIDTH 300 ;
			VALUE GetProperty (cSchirm, cFeld ,"Tooltip" ) ;
			FONT 'Arial' SIZE 12 			

	END WINDOW

	CENTER WINDOW TXT_VALID
	ACTIVATE WINDOW TXT_VALID
return Nil
*-----------------------------------------------------------------------------
function END_VALID(cSchirm,cFeld)
    SetProperty (cSchirm, cFeld ,"Value", TXT_VALID.Combo_1.DisplayValue )
    RELEASE WINDOW TXT_VALID
    SHOW WINDOW &cSchirm
    *SC_AART.SetFocus
return Nil

*=========================================
#include "HE_DATEI.PRG"
#include "HE_EAN.PRG"
#include "HE_LIEF.prg"
#include "HE_AART.PRG"
#include "HE_ALIA.prg"
#include "HE_DRUCK.prg"
#include "HE_KASSE.prg"
#include "HE_WARTUNG.prg"
#include "HE_REGAL.PRG"
*** EOF ***
