/*
* Programm HE_AART.PRG
* 
* Ideen: Artikel - Hauptstammdaten
* Autor: Hans Krasser
*/



******************************************************************************
*    SCHIRM SC_AART
*------------------------------------------------------------------------------
procedure DI_SC_AART()
    LOCAL i:=0,ci
    PRIVATE aValid:={"STK","PCK","KAR","PAL","M ","L ","ML "},l_neueDaten:=.F.,aRows [30] [9]
    PRIVATE aMWSt:={"1","2","3"},aRaum:={"VERBAND","LABOR","ANMELD","APOTH","ARZT1","ARZT2","SERVER","SOZIAL","TECHNIK"}
 
    aRows [1]	:= {"","","","","","","","",""}
    
    IF IsWindowActive(SC_AART)
        RELEASE WINDOW SC_AART
    ENDIF
    Load Window SC_AART
    * Beschriftung der Buttons, Hyde, etc.-------------
     SC_AART.Text_3.hide    
     SC_AART.Text_23.hide    
     SC_AART.Text_8.hide    
     SC_AART.Text_14.hide    
     SC_AART.Text_19.hide    
     SC_AART.Text_24.hide    
     SC_AART.Text_25.hide    
     SC_AART.Text_30.hide    
     SC_AART.Text_34.hide    
     SC_AART.Text_36.hide    
    *Variablenlisten fr IDE fehlen ###-------------

    * Laden des DB Felder in den Schirm-------------
    LO_SC_AART()


    Activate Window SC_AART
return
*------------------------------------------------------------------------------
procedure LO_SC_AART()
 *ladet Variablen aus der Datei in den Schirm
    LOCAL i:=0,ci,cText,cLNR:="",cRecNo:=""
    *PRIVATE nWorkArea:= SELECT() 
    
    SC_AART.Button_1.show   
    SC_AART.Button_2.show   
    SC_AART.Button_3.show   
    SC_AART.Button_4.show   
    SC_AART.Button_5.show   

    SC_AART.Button_7.hide  
    SC_AART.Button_8.hide 
    SC_AART.ist_PZN.hide
 	
    SELECT AART
	FOR i:=1 TO FCOUNT()
      ci:= IIF( i <10, STR(i ,1),STR(i ,2) )

      DO CASE
          CASE i = 12
	           * wandelt Text-Codes aus DBF in Value fr Combo-Box um
	           * hier stimmen die Namen NICHT mit i, ci berein !!	           
	           SET_COMBO ("SC_AART","Combo_1" ,aValid, FIELDGET( i ) )
          CASE i = 13
	           SET_COMBO ("SC_AART","Combo_2" ,aValid, FIELDGET( i ) )
          CASE i = 17
	           SET_COMBO ("SC_AART","Combo_3" ,aValid, FIELDGET( i ) )                            	           
          OTHERWISE
            cText:="Text_" + ci
            SetProperty ("SC_AART",cText ,"Value", FIELDGET( i ) )
      ENDCASE
	NEXT i
	SC_AART.Text_15.BackColor:=IIF(SC_AART.Text_15.Value="N",{255,0,0},{255,255,255} )
    SC_AART.ist_PZN.value:=IIF(aart->K1F="PH", .T., .F.)
    
    select HGUG
    seek  aart->HG
    SC_AART.Label_9.Value:=hgug->HGUG_Txt
    seek  aart->HG+aart->UG 
    SC_AART.Label_10.Value:=hgug->HGUG_Txt 

    * Lieferanten-Daten zu diesem Artikel als Grid    
    select ALIA         && Form_1.Grid_1.Item (2) := { 123.45 , date() , 2 , 10 , .T. }
    FOR i:=1 to 30
        SC_AART.Grid_1.Item (i)	:= {"","","","","","","","",""}
    next i
    set order to 3      && index on EDVNR+P_VERGL
    seek aart->EdvNr
    i:=0
    DO WHILE alia->EdvNr = aart->EdvNr .and. !eof()
        cLNR:=alia->LNR
        cRecNo:=str(recno() )
        select ALI1
        set order to 1
        seek cLNR
        
        select ALIA
        SC_AART.Grid_1.Item (++i) := {ali1->MC,BNR,MEEK,P_VERGL,LISTKZA,PEEK,KAT_KAP,cRecNo,str(alia->EKP1,12,2) }
        skip
    ENDDO

    SC_AART.Grid_1.refresh
    set order to 1          
    
   	select AART
    *SELECT (nWorkArea)
return
*-----------------------------------------------------------------------------
function SET_COMBO (cScreen,cCombo ,aItems, cDB_Var )
    LOCAL nItem:=0
    
	nItem:=ASCAN(aItems, { |x| UPPER(x) == UPPER(cDB_Var)  })
	* Wenn Bereinstimmung gefunden wird Combo auf richtigen Wert gesetzt
	*  sonst bleibt leer (value = 0)	
    SetProperty (cScreen,cCombo ,"Value", nItem )
      
return Nil

*-----------------------------------------------------------------------------
function UST_SATZ()
    * Wenn SC_AART.Text_18 gendert wird, stellt % im Klartext dar
    Local cUst_Satz:= SC_AART.Text_18.Value
IF .F.    
    IF cUst_Satz $ "123"
        SC_AART.Label_00.Value:=str(USt_Satz[ val(cUst_Satz) ],4)+"%"
    ELSE
        SC_AART.Label_00.Value:=space(1) 
    ENDIF
ENDIF   

return Nil
*------------------------------------------------------------------------------
procedure S1_SC_AART(lSpeichern,lNew)
    * kommt  entweder von BUTTON_7/Speichern oder BUTTON_8/Abbruch
    IF lSpeichern
        SA_SC_AART(lNew)   && lNew bei Add .T., bei Modify .F.
    ENDIF
    LO_SC_AART()           && stellt wieder alle buttons dar ausser 7+8
return
*------------------------------------------------------------------------------
procedure SA_SC_AART(lNew)
 * speichert Variablen aus dem Schirm in die Datei
    LOCAL i:=0,nVar_Beg:=2,ci,cText
	
    SELECT AART
    IF lNew
	    nVar_Beg:=1
      * stimmt nur, wenn NUR FIELD(1) = Key !!!
      dbAppend()
      IF NETERR()
          MsgInfo( "Derzeit ist die Datei gesperrt, Anfgen von Daten nicht mglich")
          return
      ENDIF
    ENDIF
    IF RLOCK()
	    FOR i:=nVar_Beg TO FCOUNT()
          ci:= IIF( i <10, STR(i ,1),STR(i ,2) )
          DO CASE
              CASE i = 12
                * holt den aktuellen ANZEIGE-WERT aus der Combobox, nicht .value
	            * hier stimmen die Namen NICHT mit i, ci berein !!	           
	            FieldPut( i, SC_AART.Combo_1.DisplayValue )
              CASE i = 13
	            FieldPut( i, SC_AART.Combo_2.DisplayValue )
              CASE i = 17
	            FieldPut( i, SC_AART.Combo_3.DisplayValue ) 
                *MsgInfo(SC_AART.Combo_3.DisplayValue,AART->PEVK)                              	            
              OTHERWISE
                cText:="Text_" + ci
                FieldPut( i, GetProperty ("SC_AART",cText ,"Value" ) )
          ENDCASE
	    NEXT i
	    AART->AE_DATUM:=Date()         && 15.04.2012 ergnzt
      UNLOCK
    ELSE
      MsgInfo( "Derzeit ist der Datensatz gesperrt, nderungen nicht mglich")
      return
    ENDIF

return

*-----------------------------------------------------------------------------
function SK_SC_AART(nSaetze)
    LOCAL nRecord_No:= recno(),lSatz_bewegt:=.F.
    
    SC_AART.Label_3.Value:=""    
    IF nSaetze >= 0
        IF eof()
            SC_AART.Label_3.Value:="letzter Satz"  
            PlayHand()          && hier kann nicht zu nRecord_No springen
        ELSE
            skip nSaetze
            if eof()
                SC_AART.Label_3.Value:="letzter Satz"
                PlayHand()
                go nRecord_No
            else
                lSatz_bewegt:=.T.
            endif
        ENDIF

    ELSE
        IF bof()
            SC_AART.Label_3.Value:="erster Satz"        
            PlayHand()          && hier kann nicht zu nRecord_No springen
        ELSE
            skip nSaetze
            if bof()
                SC_AART.Label_3.Value:="erster Satz" 
                PlayHand()
                go nRecord_No
            else
                lSatz_bewegt:=.T.               
            endif
        ENDIF    
    ENDIF
    
    IF lSatz_bewegt
        LO_SC_AART()
    endif
    
return Nil

*-----------------------------------------------------------------------------
function AD_SC_AART(lNew,lClear_Fields)
    * neue Daten eingeben
         
    l_neueDaten:=lNew   
    IF lNew
        CL_SC_AART(lClear_Fields)
    ENDIF 
    SC_AART.Button_1.hide   
    SC_AART.Button_2.hide   
    SC_AART.Button_3.hide   
    SC_AART.Button_4.hide   
    SC_AART.Button_5.hide   

    SC_AART.Button_7.show   
    SC_AART.Button_8.show 
    SC_AART.ist_PZN.show  

return Nil
*-----------------------------------------------------------------------------
function CL_SC_AART(lClear_Fields)
    * lschte Alles Datenfelder vor einer neuen Eingabe
    *  Falls neue DB-Felder definiert werden, fllt durch Fehlermeldung auf wenn Textfeld fehlt    
    LOCAL i,ci,cText:="",nLast_Edv:=0,nRecord_No:=recno(),l_is_Eof:=eof()
    LOCAL cData_Type:="",cEan12:=cPZ:="",cEdvNr:="",l_nur_PZ:=.T.
    LOCAL aClear_Fields:={"","","","","","","","",1,"",;
    "","","","","J","","","1","",date(),;
    date(),"","","","",0,0,0,0,0,;
    "","" }
        
	IF lClear_Fields
	 FOR i:=1 TO len(aClear_Fields)	
       ci:= IIF( i <10, STR(i ,1),STR(i ,2) )
       cText:="Text_" + ci 

       IF STRZERO(i,2) $ "12,13,17"  
            && hier werden Daten in Combo-Boxen bernommen
       ELSE  
         SetProperty ("SC_AART",cText ,"Value", aClear_Fields[i] ) 
       ENDIF

	 NEXT i
	Endif

	* Es wird die nchste freie Nummer von 1 beginnend erzeugt. 
	* Artikel bei denen das Zeichen K1F auf PH gesetzt wurde, werden dabei nicht bercksichtigt,
	* d.h. es wird die nchst-niedrigere EDVNR gesucht.
    * Zweck: Die angelegten Artikelnummern sollen nicht mit dem Nummernkreis der PZN kollidieren.)

	set order to 1
	go bottom
	DO WHILE upper(K1F) = "PH" .and. !bof()
	    skip -1
	EndDO
	
	IF upper(K1F) = "PH"
	   nLast_Edv:= 0           && es wurden bisher NUR Artikel mit PZN angelegt
	Else
	   nLast_Edv:= val(AART->EDVNR)	
	EndIF
	
	IF !l_is_Eof
	   go nRecord_No
	ENDIF
	cEdvNr:=STRZERO(nLast_Edv+1, 7, 0)
	SC_AART.Text_1.value:=cEdvNr
	
	cEan12:="2100815"+right(cEdvNr,5)  && Artikel, die KEINE PZN darstellen
	cPZ:=ean13(cEan12, l_nur_PZ)       && erhalten vorerst einen hausinternen
	SC_AART.Text_7.value:=cEan12+cPZ   && Ean-13
	SC_AART.Text_4.Setfocus
return Nil

*-----------------------------------------------------------------------------
function PZN_EINGABE()
    Local _CR:=chr(13)+chr(10)
    LOCAL cHilfe:="Sie knnen die PZN des Artikels eingeben."+_CR+"1)"+_CR
    cHilfe+="Der EAN Code wird nach den Regeln der sterr. PZN gebildet"+_CR
    cHilfe+="Lnderprfix  ARGE Pharma  PZN (6 St ohne PZ)  Prfziffer EAN "+_CR
    cHilfe+="9 0           8 8 8 8      X X X X X X         P"+_CR
    cHilfe+="Die Betriebsnummer wird von 5 auf 4 Stellen gekrzt,"+_CR
    cHilfe+="somit stehen 6 Stellen fr die Pharmazentralnummer zur Verfgung (die 7.Stelle der Pharmazentralnummer,"+_CR
    cHilfe+="die Prfziffer nach Modulo 11 muss hier nicht bercksichtigt werden, die Prffunktion wird durch die "+_CR+"EAN-Prfnummer erfllt)."+_CR
    cHilfe+=_CR+"908888XXXXXXP"+_CR    
    cHilfe+="2) "+_CR+"Das Flag K1F wird auf 'PH' gesetzt"
    cHilfe+="(Falls die PZN schon angelegt ist, kann sie kein 2. mal angelegt werden)"
    

    IF IsWindowActive(PZN_EINGAB)    && ...... KEIN gltiger Code ............
        RELEASE WINDOW PZN_EINGAB
    ENDIF
       
	DEFINE WINDOW PZN_EINGAB ;
		AT 313,242 ;
		WIDTH 1018 ;
		HEIGHT 531 ;
		TITLE 'PZN / Pharmazentralnummer' ;
		CHILD 
		
    DEFINE EDITBOX Edit_1
        ROW    20
        COL    20
        WIDTH  950
        HEIGHT 270
        VALUE ""
        FONTNAME "Courier"
        FONTSIZE 12
    END EDITBOX

    DEFINE TEXTBOX Text_1
        ROW    330
        COL    310
        WIDTH  120
        HEIGHT 24
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP "PZN bitte eingeben (7-stellig)"
        MAXLENGTH 7
        VALUE ""
    END TEXTBOX

    DEFINE LABEL Label_1
        ROW    330
        COL    30
        WIDTH  250
        HEIGHT 24
        VALUE "Pharmazentralnummer sterreich"
        FONTNAME "Arial"
        FONTSIZE 12
        RIGHTALIGN .T. 
    END LABEL

    DEFINE BUTTON Button_1
        ROW    410
        COL    440
        WIDTH  100
        HEIGHT 50
        ACTION PZN_Ende(.T.)
        CAPTION "Speichern"
        FONTNAME "Arial"
        FONTSIZE 12
        TOOLTIP "Speichert die PZN als EdvNr"
        FONTBOLD .T.
    END BUTTON

    DEFINE BUTTON Button_2
        ROW    410
        COL    330
        WIDTH  100
        HEIGHT 28
        ACTION PZN_Ende(.F.)
        CAPTION "Abbruch"
        FONTNAME "Arial"
        FONTSIZE 9
        TOOLTIP "Abbruch OHNE Speichern, zurck zum Artikelschirm"
    END BUTTON			

	END WINDOW
	
	PZN_EINGAB.Edit_1.value:=cHilfe
	PZN_EINGAB.Text_1.SetFocus    

	CENTER WINDOW PZN_EINGAB
	ACTIVATE WINDOW PZN_EINGAB	
return Nil
*-----------------------------------------------------------------------------
function PZN_Ende(lSpeichern)

    Local cPZN_Eingabe:=rtrim(PZN_EINGAB.Text_1.Value),cPZ:=""
    Local lPZ_Ok:=.T.,cPH_EAN13:="",l_nur_PZ:=.T.
    
    IF lSpeichern
        cPZN_Eingabe:=LINKS_PZN(cPZN_Eingabe)
        cPZ:=PZ_PZN(cPZN_Eingabe)
        IF cPZ <> right(cPZN_Eingabe,1)
            MsgStop("Die Prfziffer von "+cPZN_Eingabe+" ist falsch",;
             "richtig ist "+LEFT(cPZN_Eingabe,6)+"."+cPZ)
            lPZ_Ok:=.F.
        Endif
         * Lnderprfix  ARGE Pharma  PZN (6 St ohne PZ)  Prfziffer EAN             
         * 9 0           8 8 8 8      X X X X X X         P         
        If lPZ_Ok
            cPH_EAN13:="908888"+LEFT(cPZN_Eingabe,6)
            cPH_EAN13+=ean13(cPH_EAN13, l_nur_PZ)
            SC_AART.Text_1.value:=cPZN_Eingabe           
            SC_AART.Text_2.value:="PH"
            SC_AART.Text_7.value:=cPH_EAN13           
        Endif
    Endif
    If !lSpeichern
        SC_AART.ist_PZN.value:=.F.  && somit kann keine eigene EdvNr "als PZN eingeben"
    Endif
    
    IF lPZ_Ok       && Entweder richtige PZN eingegeben oder ABBRUCH    
        RELEASE WINDOW PZN_EINGAB
        SC_AART.SetFocus
        If lSpeichern
            SC_AART.Text_4.SetFocus
            SC_AART.ist_PZN.hide  
        Endif
    EndIf   
return Nil
	
*-----------------------------------------------------------------------------
function FI_SC_AART()
    LOCAL nRecordNo,cSuchstr:=rtrim(SC_AART.Text_Find.Value)
    LOCAL lnurZahl:=.T.,i,cZeichen,nlang:=0
    LOCAL cNull:="0000000000000",cPZN6:=cPZ_PZN:=" "
    *PRIVATE bColor := { || if ( recno()/2 == int(recno()/2) , { 222,222,222 } , { 192,192,192 } ) }
    PRIVATE bColor := { || if ( upper(AART->LISTKZ)="J" , { 250,250,250 } , { 255,0,0 } ) }
  
    FOR i:=1 to LEN(cSuchstr) 
        IF !substr(cSuchStr,i,1) $ "0123456789"
            lnurZahl:=.F.
            EXIT
        ENDIF 
    NEXT i
    nlang:=len(cSuchstr) 
    
    DO CASE
        case lnurZahl
            IF nlang = 1 .or. nlang = 2
                set order to 4    && index on HG+UG+upper(BEZK)
                seek cSuchstr
                 SC_AART.Title:="Artikel-Stammdaten / Sortierung n. HG+UG+Kurzbez"            
            Endif          
            IF nlang > 2 .and. nlang <= 7
                cSuchstr:=LINKS_PZN(cSuchstr)
                set order to 1      && index on EDVNR
                seek cSuchstr
                SC_AART.Title:="Artikel-Stammdaten / Sortierung n. EdvNr"                  
            Endif
            IF nlang = 13
                set order to 5      && index on EAN  to (cm_Pfad_DBF+"AART_EAN")
                cSuchstr:=LINKS_PZN(cSuchstr)
                seek cSuchstr 
                SC_AART.Title:="Artikel-Stammdaten / Sortierung n. EAN"                             
            Endif  

        case !lnurZahl
            set order to 2      && index on upper(BEZK)
                seek upper(cSuchstr)                                           
                SC_AART.Title:="Artikel-Stammdaten / Sortierung n. Kurzbez"      
    Endcase 

    IF !found()
        go top
    Endif
            
    SELECT AART
    *set order to 2            && 2:index on upper(BEZK)  to (cm_Pfad_DBF+"AART_MC")
    nRecordNo:=recno()

    IF IsWindowActive(FI_SC_AART)
	   RELEASE WINDOW FI_SC_AART
    ENDIF
    
	DEFINE WINDOW FI_SC_AART ;
		AT 0,0 ;
		WIDTH 1000 ;
		HEIGHT 440 ;
		TITLE 'Suche nach Artikel...  Doppelclick zur Auswahl (nicht gelistete Artikel sind rot)' ;
		NOSYSMENU;
		CHILD

        @0,0 BROWSE BR_AART1 ;
        WIDTH 980 ;
        HEIGHT 400 ;
        HEADERS { 'EDVNR' , 'BEZK' , 'HG' , 'UG' , 'EAN' , 'EDVNRERS' , 'BEDARF' , 'BEZ1' , 'BEZ2' , 'MELG' , 'MEVK' , 'MEVGL' , 'LISTKZ' , 'VKEMULT' , 'PEVK' , 'MWST' , 'ZACODE' , 'AE_DATUM' , 'EI_DATUM' , 'ANZLIEF' , 'UEBKZ' , 'MARKIERUNG' , 'NEU' , 'VKP1'} ;
        WIDTHS {  70,120, 40, 40,104, 20, 44,200,200, 50, 50, 24, 60, 80, 42, 30, 16, 64, 64, 16,  8,  8,  8, 80} ;
        WORKAREA AART ;
        FIELDS { 'AART->EDVNR' , 'AART->BEZK' , 'AART->HG' , 'AART->UG' , 'AART->EAN' , 'AART->EDVNRERS' , 'AART->BEDARF' , 'AART->BEZ1' , 'AART->BEZ2' , 'AART->MELG' , 'AART->MEVK' , 'AART->MEVGL' , 'AART->LISTKZ' , 'AART->VKEMULT' , 'AART->PEVK' , 'AART->MWST' , 'AART->ZACODE' , 'AART->AE_DATUM' , 'AART->EI_DATUM' , 'AART->ANZLIEF' , 'AART->UEBKZ' , 'AART->MARKIERUNG' , 'AART->NEU' , 'AART->VKP1'} ;
        DYNAMICBACKCOLOR { bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor, bColor} ;       
		TOOLTIP "Bitte Doppelclick zur Auswahl" ;
		ON DBLCLICK SUCHE_A1_0()
				
        FI_SC_AART.BR_AART1.Value := recno()
*

	END WINDOW

	CENTER WINDOW FI_SC_AART

	ACTIVATE WINDOW FI_SC_AART

Return Nil

*-----------------------------------------------------------------------------
function SUCHE_A1_0()
    * beendet die Suchfunktion und kehrt zu Artikelschirm zurck

    RELEASE WINDOW FI_SC_AART 
    SC_AART.SetFocus
    SC_AART.Label_3.Value:=""     
    LO_SC_AART()          && ladet die Variablen in die Textfelder
Return Nil

*************************************
* HG / UG VERWALTUNG                *
*-----------------------------------------------------------------------------
function SC_HGUG(cInfo,lAllow_Edit)
    * Verwaltung der Haupt- und Untergruppen fr die Artikel
    Local aCtrl_001:= {'TEXTBOX','CHARACTER'}
    Local aCtrl_002:= {'TEXTBOX','CHARACTER'}
    Local aCtrl_003:= {'TEXTBOX','CHARACTER'}
    Local cTitel
    PRIVATE lAenderung:=.F.
    
    IF cInfo = Nil
        cTitel:='Artikel HAUPTGRUPPEN und UNTERGRUPPEN'
    ELSE
       cTitel:=cInfo    
    ENDIF

    IF IsWindowActive(SC_HGUG)
        RELEASE WINDOW SC_HGUG
    ENDIF

	DEFINE WINDOW SC_HGUG ;
		AT 0,0 ;
		WIDTH 800 ;
		HEIGHT 600 ;
		TITLE cTitel ;
		NOSYSMENU;
		CHILD 

		DEFINE MAIN MENU 
			POPUP 'File'
				ITEM 'Append (Alt+A)'				ACTION SC_HGUG.GRID_HGUG.Append
				ITEM 'Get RecNo'				ACTION MsgInfo( Str(SC_HGUG.GRID_HGUG.RecNo) )
				ITEM 'Delete (Alt+D)'				ACTION SC_HGUG.GRID_HGUG.Delete
				*ITEM 'Recall (Alt+R)'				ACTION SC_HGUG.GRID_HGUG.Recall
				ITEM 'Save Pending Changes (Alt+S)'		ACTION SC_HGUG.GRID_HGUG.Save
				ITEM 'Clear Changes Buffer (Undo) (ALt+U)'	ACTION SC_HGUG.GRID_HGUG.ClearBuffer
			END POPUP
		END MENU

		select HGUG           && index on HG+UG  to (cm_Pfad_DBF+"HGUG")
		GO TOP
        DEFINE GRID GRID_HGUG
            ROW 10
            COL 10
            WIDTH 600
            HEIGHT 400
            HEADERS { 'HG','UG','HGUG_Txt'}
            WIDTHS {  60, 60,400}
            ROWSOURCE "HGUG"
            COLUMNFIELDS { 'HG','UG','HGUG_Txt'}
            ALLOWEDIT lAllow_Edit
            ALLOWAPPEND .T.
            COLUMNCONTROLS {aCtrl_001,aCtrl_002,aCtrl_003}
            VALUE 1
            ONCHANGE lAenderung:=.T.
            *ON HEADCLICK { {|| END_HGUG() } , {|| END_HGUG() } , {||  END_HGUG() } }
            *OnDblClick {|| END_HGUG(lAenderung,cInfo) }
        END GRID
			
		DEFINE BUTTON BUTTON2
			ROW	500
			COL	10
			CAPTION	'Neuer Eintrag'
			ACTION	SC_HGUG.GRID_HGUG.Append
			WIDTH	150
		END BUTTON
        
		DEFINE BUTTON BUTTON1
			ROW	500
			COL	200
			CAPTION	'Sichern'
			ACTION	SC_HGUG.GRID_HGUG.Save
			WIDTH	150
		END BUTTON
        
		DEFINE BUTTON BUTTON3
			ROW	500
			COL	400
			CAPTION	'Ende'
			ACTION	END_HGUG(lAenderung,cInfo)
			WIDTH	150
		END BUTTON	            	        		
	END WINDOW

	CENTER WINDOW SC_HGUG

	ACTIVATE WINDOW SC_HGUG
	*---------------------------------

Return Nil

*-----------------------------------------------------------------------------
function END_HGUG(lAenderung,cInfo)
    IF lAenderung
        IF MsgYesNO("Sollen nderungen gesichert werden ?")
            SC_HGUG.GRID_HGUG.Save
        ENDIF
    ENDIF
    RELEASE WINDOW SC_HGUG
    IF cInfo <> Nil         && kommt vom Feld HG oder UG, muss dorthin zurck
        SC_AART.SetFocus
    ENDIF
Return Nil

*-----------------------------------------------------------------------------
*-----------------------------------------------------------------------------
function HG_CHECK()
    * prft bei SC_AART.Text_5 onLostFocus, ob die HG stimmt
    PRIVATE nWorkArea:= SELECT() 
    
    select HGUG
    set filter to UG="00"
    seek  rtrim(SC_AART.Text_5.Value)
    IF !found()
        SC_HGUG1("Bitte Artikel-Hauptgruppe (HG) mit Doppelclick whlen" ) 
        SC_AART.Text_5.Value:=hgug->HG      
    ENDIF 
    SC_AART.Label_9.Value:=hgug->HGUG_Txt    
    set filter to 

    SELECT (nWorkArea)
Return Nil
*-----------------------------------------------------------------------------
function UG_CHECK()
    * prft bei SC_AART.Text_6 onLostFocus, ob die UG stimmt
    LOCAL cHG:=rtrim(SC_AART.Text_5.Value),cUG:=rtrim(SC_AART.Text_6.Value)
    PRIVATE nWorkArea:= SELECT() 
    
    select HGUG
    seek cHG
    IF !found()
        MsgInfo("Artikel-Hauptgruppe (HG) existiert nicht",cHG )       
        SC_AART.Text_5.SetFocus
        SELECT (nWorkArea)        
        RETURN    
    ENDIF 
    
    seek cHG+cUG   
    IF !found()
        set filter to HG=cHG .and. UG <> space(2).and. UG <> "00"
        go top
        SC_HGUG1("Bitte Artikel-Untergruppe (UG) mit Doppelclick whlen" ) 
        SC_AART.Text_6.Value:=hgug->UG      
    ENDIF 
    SC_AART.Label_10.Value:=hgug->HGUG_Txt    
    set filter to 

    SELECT (nWorkArea)
Return Nil    
*-----------------------------------------------------------------------------
function SC_HGUG1(cTitel)
    * Suchen der Haupt- und Untergruppen fr die Artikel
    Local aCtrl_001:= {'TEXTBOX','CHARACTER'}
    Local aCtrl_002:= {'TEXTBOX','CHARACTER'}
    Local aCtrl_003:= {'TEXTBOX','CHARACTER'}

    IF IsWindowActive(SC_HGUG)
        RELEASE WINDOW SC_HGUG
    ENDIF

	DEFINE WINDOW SC_HGUG ;
		AT 0,0 ;
		WIDTH 800 ;
		HEIGHT 600 ;
		TITLE cTitel ;
		NOSYSMENU;
		CHILD 

		select HGUG           && index on HG+UG  to (cm_Pfad_DBF+"HGUG")
		GO TOP
        DEFINE GRID GRID_HGUG
            ROW 10
            COL 10
            WIDTH 600
            HEIGHT 400
            HEADERS { 'HG','UG','HGUG_Txt'}
            WIDTHS {  60, 60,400}
            ROWSOURCE "HGUG"
            COLUMNFIELDS { 'HG','UG','HGUG_Txt'}
            COLUMNCONTROLS {aCtrl_001,aCtrl_002,aCtrl_003}
            VALUE 1
            OnDblClick {|| END_HGUG1() }
        END GRID
       
		DEFINE BUTTON BUTTON3
			ROW	500
			COL	400
			CAPTION	'Ende'
			ACTION	END_HGUG1()
			WIDTH	150
		END BUTTON	            	        		
	END WINDOW

	CENTER WINDOW SC_HGUG

	ACTIVATE WINDOW SC_HGUG
Return Nil

*-----------------------------------------------------------------------------
function END_HGUG1()
    RELEASE WINDOW SC_HGUG
    SC_AART.SetFocus
Return Nil

******************************************************************************
*   ENDE SCHIRM SC_AART
*------------------------------------------------------------------------------
procedure CLOSE_AART()
    Release Window SC_AART
return
