/*
* Programm HE_ALIA.PRG
* 
* Ideen: Artikel - Lieferantendaten
* Autor: Hans Krasser
*/



******************************************************************************
*    SCHIRM SC_ALIA
*------------------------------------------------------------------------------
procedure DI_SC_ALIA(lNew)
    LOCAL i:=0,ci
    PRIVATE aValid:={"STK","PCK","KAR","PAL","M ","L ","ML "},l_neueDaten:=.F.
    PRIVATE aMWSt:={"1","2","3"},aRaum:={"VERBAND","LABOR","ANMELD","APOTH","ARZT1","ARZT2","SERVER","SOZIAL","TECHNIK"}
    PRIVATE lALNew:=lNew
    

    IF IsWindowActive(SC_ALIA)
        RELEASE WINDOW SC_ALIA
    ENDIF
    Load Window SC_ALIA

    * Beschriftung der Buttons, Hyde, etc.-------------
    * Laden des DB Felder in den Schirm-------------
    IF lNew
        CL_SC_ALIA()
    ELSE
        LO_SC_ALIA()    
    ENDIF    



    Activate Window SC_ALIA
return

*------------------------------------------------------------------------------
procedure LO_SC_ALIA()
 *ladet Variablen aus der Datei in den Schirm
    LOCAL i:=0,ci,cText,cEdvNr:=aart->EdvNr,aTemp
    *PRIVATE nWorkArea:= SELECT() 
    
    *SC_ALIA.Button_1.show   
    *SC_ALIA.Button_2.show   
    *SC_ALIA.Button_3.show   
    *SC_ALIA.Button_4.show   
    *SC_ALIA.Button_5.show   

    *SC_ALIA.Button_7.hide  
    *SC_ALIA.Button_8.hide 
 	
    SELECT ALIA
    set order to 1
    i := SC_AART.Grid_1.Value

	If i != 0          && nur ausfhren, wenn eine Grid-Zeile markiert ist
		aTemp := SC_AART.Grid_1.Item(i)

		*SC_AART.Grid_1.DeleteItem(i)
		IF val(aTemp[8]) > 0
		   go val(aTemp[8])
	       FOR i:=1 TO FCOUNT()
            ci:= IIF( i <10, STR(i ,1),STR(i ,2) )

              DO CASE
                  CASE i = 6
	                  * wandelt Text-Codes aus DBF in Value fr Combo-Box um
        	           * hier stimmen die Namen NICHT mit i, ci berein !!	           
        	           SET_COMBO ("SC_ALIA","Combo_3" ,aValid, FIELDGET( i ) )
                  CASE i = 8
        	           SET_COMBO ("SC_ALIA","Combo_1" ,aValid, FIELDGET( i ) )
                  CASE i = 10
        	           SET_COMBO ("SC_ALIA","Combo_2" ,aValid, FIELDGET( i ) )                            	           
                  OTHERWISE
                    cText:="Text_" + ci
                    SetProperty ("SC_ALIA",cText ,"Value", FIELDGET( i ) )
            ENDCASE
	       NEXT i
	       SC_ALIA.Text_9.BackColor:=IIF(SC_ALIA.Text_9.Value="N",{255,0,0},{255,255,255} )	
           SC_ALIA.Label_8.Value:=IIF( upper(ALI1->CODE)="B","Brutto", "NETTO" )       
        Endif		
	Else
		MsgInfo("Bitte vor nderungen Lieferantendaten mit der Maus markieren"  )    		
	EndIf

return

*------------------------------------------------------------------------------
procedure S1_SC_ALIA(lSpeichern,lNew)
    * kommt  entweder von BUTTON_7/Speichern oder BUTTON_8/Abbruch
    IF lSpeichern
        SA_SC_ALIA(lNew)   && lNew bei Add .T., bei Modify .F.
    ENDIF

    RELEASE WINDOW SC_ALIA 
LO_SC_AART()    
    SC_AART.SetFocus
    *SC_ALIA.Label_3.Value:=""     

return
*------------------------------------------------------------------------------
procedure SA_SC_ALIA(lNew)
 * speichert Variablen aus dem Schirm in die Datei
    LOCAL i:=0,nVar_Beg:=3,ci,cText
	
    SELECT ALIA
    IF lNew
	    nVar_Beg:=1
      * hier sind FIELD(1+2) = Key !!!
      dbAppend()
      IF NETERR()
          MsgInfo( "Derzeit ist die Datei gesperrt, Anfgen von Daten nicht mglich")
          return
      ENDIF
    ENDIF
    IF RLOCK()
	    FOR i:=nVar_Beg TO FCOUNT()
          ci:= IIF( i <10, STR(i ,1),STR(i ,2) )
          DO CASE
              CASE i = 6
                * holt den aktuellen ANZEIGE-WERT aus der Combobox, nicht .value
	            * hier stimmen die Namen NICHT mit i, ci berein !!	           
	            FieldPut( i, SC_ALIA.Combo_3.DisplayValue )
              CASE i = 8
	            FieldPut( i, SC_ALIA.Combo_1.DisplayValue )
              CASE i = 10
	            FieldPut( i, SC_ALIA.Combo_2.DisplayValue ) 
                *MsgInfo(SC_ALIA.Combo_2.DisplayValue,ALIA->MEEK)                              	            
              OTHERWISE
                cText:="Text_" + ci
                FieldPut( i, GetProperty ("SC_ALIA",cText ,"Value" ) )
          ENDCASE
	    NEXT i
      UNLOCK
    ELSE
      MsgInfo( "Derzeit ist der Datensatz gesperrt, nderungen nicht mglich")
      return
    ENDIF

return

*-----------------------------------------------------------------------------
function CL_SC_ALIA()
    * lschte Alles Datenfelder vor einer neuen Eingabe
    *  Falls neue DB-Felder definiert werden, fllt durch Fehlermeldung auf wenn Textfeld fehlt    
    LOCAL i,ci,cText:="",nLast_Edv:=0,nRecord_No:=recno(),l_is_Eof:=eof()
    LOCAL cData_Type:="",cCombo:=""
    LOCAL aClear_Fields:={"","","","","",1,"0001.000",1,"J",1,;
    1.0,"",1,1.0,1.0,"",date(),date(),"","",;
    0,"" }
        
	*
	FOR i:=1 TO len(aClear_Fields)	
       ci:= IIF( i <10, STR(i ,1),STR(i ,2) )
       cText:="Text_" + ci 


       IF STRZERO(i,2) $ "06,08,10"  
         DO CASE
            CASE i = 6
                cCombo:="Combo_3"
            CASE i = 8
	            cCombo:="Combo_1"
            CASE i = 10
	            cCombo:="Combo_2"                 
                *MsgStop("STRZERO(i,2) "+ci+"/"+cCombo)       
                * hier werden Daten in Combo-Boxen bernommen
         ENDCASE                
         SetProperty ("SC_ALIA",cCombo ,"Value", aClear_Fields[i] )             
       ELSE  
         SetProperty ("SC_ALIA",cText ,"Value", aClear_Fields[i] ) 
       ENDIF
	NEXT i
	
	SC_ALIA.Text_1.value:=aart->EDVNR
return Nil
*-----------------------------------------------------------------------------
function LNR_CHECK(Schirm,Feld)
    Local cLNR_Eingabe
    Local nWorkArea:= SELECT()
       
    cLNR_Eingabe:=GetProperty (Schirm,Feld ,"Value" )
    cLNR_Eingabe:=STRZERO( val(cLNR_Eingabe),6,0  )
    select ALI1
    set order to 1
    seek cLNR_Eingabe
    If !found()
        FI_SC_LIEF2()       && Suche nach Lieferant, auswahl mit Doppelclick
        cLNR_Eingabe:=ali1->lnr
    Endif
    SetProperty (Schirm,Feld ,"Value", cLNR_Eingabe ) 
    IF  upper(Schirm)= "SC_ALIA"
        sc_alia.label_1.value:=ali1->MC
    endif  

    SELECT (nWorkArea)
return Nil

*-----------------------------------------------------------------------------
function VERGL_PREIS()
    * nach nderung von EKP1 wird der P_VERGL berechnet
    * SC_LIEF1.Text_5 ="B" Lieferant hat Bruttopreise, sonst Netto + Ust
    * SC_AART.Text_18 = MWSt-Code 
    * USt_Satz:={ 20,10, 0} 
    * SC_ALIA.Text_21 = EKP1
    * SC_ALIA.Text_14 = VERGLFAKT
                      
    Local cUst_Satz:= AART->MWST,nUstFakt:=1,nVERGLFAKT:=SC_ALIA.Text_14.Value
    Local cBrutto_Ntto:=upper(ALI1->CODE),nEKP:=SC_ALIA.Text_21.Value 
    Local nVerglPreis:=0
    
    IF cBrutto_Ntto = "B"
        nUstFakt:=1         && hier ist schon USt im EKP1 enthalten   
    ELSE
        IF cUst_Satz $ "123"
            nUstFakt:=(100+USt_Satz[ val(cUst_Satz) ])/100
        ELSE
            nUstFakt:=0     && soll sofort auf  falschen USt-Code aufmerksam machen 
        ENDIF
    ENDIF 
    IF nVERGLFAKT > 0
        nVerglPreis:=nEKP * nUstFakt /nVERGLFAKT
    ELSE
        nVerglPreis:=0
    ENDIF
    SC_ALIA.Text_7.Value:=STRZERO(nVerglPreis,10,4)
return Nil

*-----------------------------------------------------------------------------
function DEZ_CHECK(Schirm,Feld,nLang,nDec)
    Local cLNR_Eingabe,nTemp,i,ch,cTemp_Zahl:=""
    
    cLNR_Eingabe:=GetProperty (Schirm,Feld ,"Value" )
    
    FOR i:=1 to len(cLNR_Eingabe)
        ch:= substr(cLNR_Eingabe,i,1)
        DO CASE
            CASE ch $ "0123456789."
                cTemp_Zahl+=ch
            CASE ch = "," 
                cTemp_Zahl+="."                       
        ENDCASE
    NEXT i
    nTemp:=val(cTemp_Zahl)
    SetProperty (Schirm,Feld ,"Value", STRZERO(nTemp,nLang ,nDec ) ) 
return Nil
*-----------------------------------------------------------------------------
function FI_SC_LIEF2()
    LOCAL nRecordNo

    set order to 2            && 2:index on UPPER(MC)  to  (cm_Pfad_DBF+"ALI1_MC")
    go top
    nRecordNo:=recno()

    IF IsWindowActive(FI_SC_LIEF1)
	   RELEASE WINDOW FI_SC_LIEF1
    ENDIF
    
	DEFINE WINDOW FI_SC_LIEF1 ;
		AT 0,0 ;
		WIDTH 900 ;
		HEIGHT 440 ;
		TITLE 'Suche nach Lieferanten...  Doppelclick zur Auswahl' ;
		NOSYSMENU;
		CHILD
		
        @0,0 BROWSE BROWSE_LIEF1 ;
        WIDTH 880 ;
        HEIGHT 400 ;
        HEADERS { 'LNR' , 'MC' , 'NAME' , 'BRA' , 'STR' , 'PLZ' , 'ORT' , 'STKZ' , 'TELEFON' , 'EMAIL' , 'FAX' , 'GF' , 'VKL' , 'SB' , 'BEST_ARTC' , 'BEST_ARTT' , 'ERSTKO3' , 'ZART1' , 'ZART2' , 'ZART3' , 'FBEZ1' , 'FBEZ2' , 'FBEZ3' , 'LART1' , 'LART2' , 'WC' , 'MBESTWERT' , 'FREHAUS_AB' , 'LLIST_Z'} ;
        WIDTHS {  90, 64,240,100,70, 40,100, 2,160,240,160,240,240,240, 16,160,240,240,240,240,240,240,240,240,240, 24, 100,100,  8} ;
        WORKAREA ALI1 ;
        FIELDS { 'ALI1->LNR' , 'ALI1->MC' , 'ALI1->NAME' , 'ALI1->BRA' , 'ALI1->STR' , 'ALI1->PLZ' , 'ALI1->ORT' , 'ALI1->STKZ' , 'ALI1->TELEFON' , 'ALI1->EMAIL' , 'ALI1->FAX' , 'ALI1->GF' , 'ALI1->VKL' , 'ALI1->SB' , 'ALI1->BEST_ARTC' , 'ALI1->BEST_ARTT' , 'ALI1->ERSTKO3' , 'ALI1->ZART1' , 'ALI1->ZART2' , 'ALI1->ZART3' , 'ALI1->FBEZ1' , 'ALI1->FBEZ2' , 'ALI1->FBEZ3' , 'ALI1->LART1' , 'ALI1->LART2' , 'ALI1->WC' , 'ALI1->MBESTWERT' , 'ALI1->FREHAUS_AB' , 'ALI1->LLIST_Z'} ;
		TOOLTIP "Bitte Doppelclick zur Auswahl" ;
		ON DBLCLICK SUCHE_L2_0()
				
        FI_SC_LIEF1.BROWSE_LIEF1.Value := recno()

	END WINDOW

	CENTER WINDOW FI_SC_LIEF1

	ACTIVATE WINDOW FI_SC_LIEF1

Return Nil

*-----------------------------------------------------------------------------
function SUCHE_L2_0()
    * beendet die Suchfunktion und kehrt zu Lieferantenschirm zurck

    RELEASE WINDOW FI_SC_LIEF1 

    SC_ALIA.SetFocus
Return Nil

