/*
* Programm HE_DRUCK.prg
* 
* Ideen: 
* Autor: Hans Krasser
*/

*************************************************
*  DRUCKEN                                      *
*------------------------------------------------
function HLP_ORL1()
    Execute FILE "HELP_Orderliste_01.txt"
REturn Nil
*-----------------------------------------------------------------------------*
procedure DR_MEDIKA(cListenArt)
	* druckt alle Artikel in AART aus
    
	LOCAL i,ci,nRecord:=0,nOrder:= INDEXORD()
    PRIVATE nZeile_hoch:=5,nPat_Sheet:=0,nZeilenNr:=nSeitenNr:=1
    PRIVATE nRand_O:=10,nDR_Spalte:=1,nSpalt_Breit:=10,cListe:=cListenArt
	PRIVATE nZeilen_Max:=270 ,nPreis_Alle:=0,nCopies:=1,iCopy,cLagerOrt:=" "  

    IF cListenArt = "RET"
        nCopies:=2
    ENDIF
    
    FOR iCopy :=1 to nCopies    &&............
    nPreis_Alle:=0
    *SELECT PRINTER DEFAULT   
    SELECT PRINTER DIALOG TO lSuccess PREVIEW 
	If !lSuccess 
	   RETURN
	EndIf
	START PRINTDOC
	

    SELECT AART         && set index to (cm_Pfad_DBF+"AART"), (cm_Pfad_DBF+"AART_MC"),(cm_Pfad_DBF+"AART_LA")
    set order to 3      && index on upper(LAGERRAUM)+LAGER_REG+upper(BEZK)
    go top
    cLagerOrt:=aart->LAGERRAUM
    REP_HEADER(cListe)    
 
    DO WHILE !eof() 
        nRecord:=recno()    
        nOrder:= INDEXORD() 
        IF upper(AART->LISTKZ)="J"  
            PROT_LINE(cListe)   && auf der Orderliste stehen NUR GELISTETE Artikel
        Endif       
        
        SELECT aart 
        *SET ORDER TO nOrder             
        *go nRecord
         
        skip
    ENDDO
    set order to 1    
	PROT_FOOTER(cListe)    
	
	END PRINTDOC
	NEXT iCopy  &&.............................
   	
return

*-----------------------------------------------------------------------------*
procedure REP_HEADER(cListe)
    * beginnt neues Reportblatt 
    * nZeilenNr:=nSeitenNr:=1 Lab_Spalte[15]
    *DR_MEDIKA("Ersatz+Etti")     
    LOCAL cCode2,cCode1,nlang,cTxt_Ergaenz:=" "
    LOCAL cCodes:=""


    START PRINTPAGE    
    DO CASE
        CASE cListe $ "ORDERLISTE"
            *cTxt_Ergaenz+="ORDERLISTE "       
        CASE cListe = "Ersatz+Liste" 
          cTxt_Ergaenz+="/Lagerstandsgrenzen "                            
    ENDCASE
    
    REP_HEADER1(cListe,cTxt_Ergaenz)                 
return

*-----------------------------------------------------------------------------*
procedure REP_HEADER1(cListe,cTxt_Ergaenz)
    * druckt je nach Listenart VERSCHIEDENE Header
        
    nZeilenNr:= nRand_O         && bei Etikettenpapier ev. anders !!
    DO CASE
        CASE cListe $ "ORDERLISTE"
            REP_HEADER2(cListe,cTxt_Ergaenz)  
            @ nZeilenNr, 10 PRINT "REGAL" FONT "Arial" SIZE 11                                    
            @ nZeilenNr, 56 PRINT "BEZEICHNUNG" FONT "Arial" SIZE 11                  	                    
            @ nZeilenNr,170 PRINT "BESTELLUNG" FONT "Arial" SIZE 11                        	                   
            REP_ADV_LINE()
            @ nZeilenNr, 8 PRINT LINE TO nZeilenNr,200 PENWIDTH 0.1 
            @ 149,  8 PRINT LINE TO  149,12 PENWIDTH 0.3    && Lochermarke                         
            REP_ADV_LINE() 
        CASE cListe = "Ersatz+Etti"         && .................. 
                     
                                                 
    ENDCASE

return

*------------------------------------------------
function REP_HEADER2(cListe,cTxt_Ergaenz)
    * druckt den Kopf der Ordination, allgemeiner Kopf aller Listen           
    @ 10, 8 PRINT RECTANGLE TO 22,200 PENWIDTH 0.4
    @ nZeilenNr, 10 PRINT "Seite "+STR(nSeitenNr,3) FONT "Arial" SIZE 11 
    @ nZeilenNr, 35 PRINT "Ord. "+DR_Name FONT "Arial" SIZE 12  
    @ nZeilenNr, 170 PRINT DTOC( date() ) FONT "Arial" SIZE 11 
    REP_ADV_LINE()
    @ nZeilenNr, 35 PRINT cListe+cTxt_Ergaenz+aart->LAGERRAUM FONT "Arial" SIZE 14       
    @ nZeilenNr, 170 PRINT TIME() FONT "Arial" SIZE 11     
    REP_ADV_LINE(2) 
            
Return Nil 

*-----------------------------------------------------------------------------*
procedure PROT_LINE(cListe)
    LOCAL cString2:=""
    * druckt 1 Patienten auf das Blatt                  nZeileHoch:=13.7
    LOCAL i, nZeile_eff, nSpalte_H:=4.65, nSpalte_eff
    LOCAL CN:=" ",nVar_Ofset:=5,nField,cCheckbox,nSp_Offset:=nMon_Schn:=0
    LOCAL cSV_Pat:=space(1),cPZN:="",cEan12:=""
    PRIVATE nTagesMax:=0,cVerglDat:=" "

    nPat_Sheet++                        && Anzahl der Stze von VOR_DET auf der Seite

    DO CASE
      CASE cListe $ "ORDERLISTE" 
       IF aart->BEDARF > 0              && nur andrucken, wenn Bedarf vorhanden
        IF cLagerOrt <> aart->LAGERRAUM && Jeder Raum kommt auf neue Seite
            REP_ADV_PAGE()
            cLagerOrt=aart->LAGERRAUM
        Endif
        
        IF nZeilenNr+nZeile_hoch*3 > nZeilen_Max    && nicht genug Platz fr Ean
            REP_ADV_PAGE()       
        ENDIF
        
        cEan12:=left(aart->EAN,12)
        @ nZeilenNr-3, 16 PRINT ean13(cEan12 ) FONT "Code EAN13" SIZE 40        
        @ nZeilenNr, 56 PRINT aart->BEZ1 FONT  "Courier" SIZE 11 
        REP_ADV_LINE()                
        @ nZeilenNr, 56 PRINT aart->BEZ2+" ......." FONT  "Courier" SIZE 11 
        REP_ADV_LINE(2) 
        @ nZeilenNr, 10 PRINT aart->LAGER_REG FONT  "Arial" SIZE 12         
        @ nZeilenNr, 56 PRINT "Mindestbedarf "+str(aart->BEDARF,8,2)+" "+;
         AART->MELG FONT  "Courier" SIZE 11      
        REP_ADV_LINE()
        @ nZeilenNr, 12 PRINT LINE TO nZeilenNr,180 PENWIDTH 0.1                                                    
        REP_ADV_LINE()    
       Endif            
       
     CASE cListe = "Ersatz+Etti"         && .................. 
           
    ENDCASE
    SELECT aart        
                               
return

*-----------------------------------------------------------------------------*
procedure PROT_FOOTER(cListe)
    * druckt ein volles Blatt fr LG fertig und Stellt auf Null
    LOCAL cAblage:=""   

    DO CASE
      CASE cListe $ "ORDERLISTE"
        IF cListe = "ORDERLISTE"
            cAblage:="Sortierung nach RAUM und Lager/Regal bitte Bestellmenge eintragen"
            @ nZeilen_Max+nZeile_hoch+nZeile_hoch, 11 PRINT cAblage FONT  "Arial" SIZE 11         
        ENDIF 
        IF cListe = "ABG"
            @ nZeilen_Max+nZeile_hoch+nZeile_hoch, 11 PRINT "Ablegen im Ordner 'ABGELAUFENE WARE' " FONT  "Arial" SIZE 11         
        ENDIF                   
        @ nZeilen_Max+nZeile_hoch, 8 PRINT LINE TO nZeilen_Max+nZeile_hoch,200 PENWIDTH 0.1 

        *@ nZeilen_Max+nZeile_hoch+nZeile_hoch,130 PRINT "Gesamt " FONT  "Courier" SIZE 12        
        *@ nZeilen_Max+nZeile_hoch+nZeile_hoch,155 PRINT STR(nPreis_Alle,7,2)  FONT  "Courier" SIZE 14 BOLD
       


    ENDCASE
    
    nPat_Sheet:=0
	END PRINTPAGE    
return

*-----------------------------------------------------------------------------*
procedure REP_ADV_LINE(nLines)
    LOCAL nZeilen,i
    
    IF nLines = NIL
        nZeilen:=1
    ELSE
        nZeilen:=nLines
    ENDIF 
    
    FOR i:= 1 TO nZeilen
        nZeilenNr+=nZeile_hoch
        IF nZeilenNr > nZeilen_Max
            REP_ADV_PAGE()
        ENDIF   
    NEXT i

return

*-----------------------------------------------------------------------------*
procedure REP_ADV_PAGE()

    REP_FOOTER()
    nSeitenNr++
    REP_HEADER(cListe)   
return

*-----------------------------------------------------------------------------*
procedure REP_FOOTER()
    * druckt ein volles Reportblatt fertig und Stellt auf Null
    DO CASE
      CASE cListe $ "####"  
        @ nZeilen_Max+nZeile_hoch, 8 PRINT LINE TO nZeilen_Max+nZeile_hoch,200 PENWIDTH 0.1 
        @ nZeilen_Max+nZeile_hoch+nZeile_hoch,130 PRINT "Gesamt " FONT  "Courier" SIZE 12        
        @ nZeilen_Max+nZeile_hoch+nZeile_hoch,155 PRINT STR(nPreis_Alle,7,2)  FONT  "Courier" SIZE 14 BOLD

    ENDCASE
    
    nPat_Sheet:=0                
	END PRINTPAGE    
return

*************************************************
*  FEHLERPROTOKOLL ORDERLISTE
*  
*------------------------------------------------
function CHK_ORDER()
    Local cEdvNr:="",lKann_liefern:=.F.
    
    select AART
    IF !FLOCK()
        MsgStop("Derzeit keine alleinigen Zugriffsrechte auf Artikeldatei")
        Return
    ENDIF
    replace all K2F with space(2)
    replace all UEBKZ with space(1)
       
    go top
    DO While !eof()
        cEdvNr=EDVNR
        lKann_liefern:=.F.
        
        select ALIA
        set order to 1          && index on EDVNR+LNR 
        seek cEdvNr
        IF !found()
            AART->K2F:="L0"     && kein Lieferant fr diesen Artikel
        ELSE
            DO while EDVNR=aart->EDVNR .and. !lKann_liefern .and. !eof()
              IF upper(ALIA->LISTKZA) = "J" 
                select ALI1
                set order to 1      && index on LNR
                seek ALIA->LNR
                IF upper(ali1->LLIST_Z)="J"
                    lKann_liefern:=.T.
                Endif
              Endif
              
              select ALIA            
              skip
            Enddo
        Endif
        
        select AART        
        If !lKann_liefern
            AART->UEBKZ:="X"     && keine gltigen Lieferanten-Artikeldaten !
        Endif        
        skip
    Enddo   
    set filter to K2F <> space(2) .OR.UEBKZ <> space(1)  
    
    set order to 4      && index on HG+UG+upper(BEZK) 
    select AART
    go top
    REP_AART_2()        && REP_AART_1()
    *ExecuteReport('CHK_ORDER',.t.,.t. ) 
    set filter to           
    set order to 1
    unlock     
Return Nil

*------------------------------------------------
function REP_AART_1()
    *	NFORMATS	{'','','','999,999,999.99'}					;
    *	
    select AART   
    set order to 4      && index on HG+UG+upper(BEZK)          
	DO REPORT ;
		TITLE		'FEHLERPROTOKOLL | ODERLISTE Sort: HG+UG'			;
		HEADERS		{'','b','','','BED','',''} , {'K2F','kz','HG','UG','ARF','EdvNr','BEZEICHNUNG'}	;
		FIELDS		{'K2F','UEBKZ','HG','UG','BEDARF','EDVNR','BEZ1'}				;
		WIDTHS		{3,2,2,2,3,7,35}							;
		TOTALS		{.F.,.F.,.F.,.F.,.F.,.F.,.F.}						;
		NFORMATS	{'','','','','9999','',''}					;
		WORKAREA	AART								;
		LPP		60								;
		CPL		80								;
		LMARGIN		3								;
		PAPERSIZE	DMPAPER_A4							;
		PREVIEW										; 
		SELECT										;
		MULTIPLE									;
		GROUPED BY	'HG'								;
		HEADRGRP	'HG'
        
        set order to 1        									
Return Nil

*------------------------------------------------
function REP_AART_2()

	DEFINE REPORT Report1

		* Report Layout ***********************************************

		BEGIN LAYOUT 
			PAPERSIZE	PRINTER_PAPER_A4
			ORIENTATION	PRINTER_ORIENT_PORTRAIT 
		END LAYOUT

		* Header Band *************************************************

		BEGIN HEADER

			BANDHEIGHT	25

			BEGIN LINE
				FROMROW		23
				FROMCOL		10
				TOROW		23
				TOCOL		200
				PENWIDTH	0.1
				PENCOLOR	{ 0 , 0 , 0 }
			END LINE

			BEGIN TEXT
				EXPRESSION	'Fehlerprotokoll Orderliste  '+DTOC(Date()  )+" / "+TIME()
				ROW		13	
				COL		10	
				WIDTH		190	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	18	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left
			END TEXT

			BEGIN PICTURE
				VALUE		'hmg.jpg'
				ROW		10	
				COL		189	
				WIDTH		11	
				HEIGHT		11	
				STRETCH		.F.
			END PICTURE

		END HEADER

		* Detail Band *************************************************

		BEGIN DETAIL

			BANDHEIGHT	6

			BEGIN TEXT
				EXPRESSION	aart->K2F
				ROW		2	
				COL		15	
				WIDTH		10	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	aart->UEBKZ
				ROW		2	
				COL		20	
				WIDTH		10
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	aart->HG+'/'
				ROW		2	
				COL		35	
				WIDTH		10	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	aart->UG
				ROW		2	
				COL		40
				WIDTH		10	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	aart->BEDARF
				ROW		2	
				COL		50	
				WIDTH		15	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT
*K2F','UEBKZ','HG','UG','BEDARF','EDVNR','BEZ1'
			BEGIN TEXT
				EXPRESSION	aart->EDVNR
				ROW		2	
				COL		60	
				WIDTH		15	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT
			
			BEGIN TEXT
				EXPRESSION	AART->LISTKZ+"-"+aart->BEZ1
				ROW		2	
				COL		80	
				WIDTH		120	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT			

		END DETAIL

		* Footer Band *************************************************

		BEGIN FOOTER

			BANDHEIGHT	27

			BEGIN LINE
				FROMROW		4
				FROMCOL		10	
				TOROW		4	
				TOCOL		200	
				PENWIDTH	0.1	
				PENCOLOR	{ 0 , 0 , 0 }	
			END LINE

			BEGIN TEXT
				EXPRESSION	'Page. No:' + Str(_PageNo,2)
				ROW		6	
				COL		10	
				WIDTH		30	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

			BEGIN TEXT
				EXPRESSION	'L0=kein Lieferant   X=kein AKTIVER Lieferant  J/N=AART->LISTKZ'
				ROW		6	
				COL		50	
				WIDTH		150	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT
			BEGIN TEXT
				EXPRESSION	'Artikel mit AART->LISTKZ="N" werden auf Orderliste NICHT gedruckt'
				ROW		10	
				COL		50	
				WIDTH		150	
				HEIGHT		10	
				FONTNAME	'Helvetica'
				FONTSIZE	10	
				FONTBOLD	.F.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT
		END FOOTER

		* Summary Band ************************************************

		BEGIN SUMMARY

			BANDHEIGHT	50

			BEGIN TEXT
				EXPRESSION	'Total Records: ' + Str(RecCount()) 
				ROW		10
				COL		20	
				WIDTH		100	
				HEIGHT		30
				FONTNAME	'Helvetica'
				FONTSIZE	12	
				FONTBOLD	.T.
				FONTITALIC	.F.
				FONTUNDERLINE	.F.
				FONTSTRIKEOUT	.F.
				FONTCOLOR	{ 0 , 0 , 0 }
				ALIGNMENT	Left 
			END TEXT

		END SUMMARY

	END REPORT
    ExecuteReport('Report1',.t.,.t. )
Return


*************************************************
*  ARTIKELLISTE - SYSTEMATISCH nach HG-UG
*  
*------------------------------------------------
function ART_LIST1()
    select AART   
    set order to 4      && index on HG+UG+upper(BEZK)  
    set filter to LISTKZ = "J"
    go top        
	DO REPORT ;
		TITLE		'Artikelliste systematisch |nur gelistete Art. / Sort: HG+UG'			;
		HEADERS		{'','','BED','','','',''} , {'HG','UG','ARF','Edvnr','BEZEICHNUNG','Raum','Regal'}	;
		FIELDS		{'HG','UG','BEDARF','Edvnr','BEZ1','LAGERRAUM','LAGER_REG'}				;
		WIDTHS		{2,2,4,7,35,8,10}							;
		TOTALS		{.F.,.F.,.F.,.F.,.F.,.F.,.F.}						;
		NFORMATS	{'','','9999','','','',''}					;
		WORKAREA	AART								;
		LPP		60								;
		CPL		80								;
		LMARGIN		3								;
		PAPERSIZE	DMPAPER_A4							;
		PREVIEW										; 
		SELECT										;
		MULTIPLE									;
		GROUPED BY	'HG'								;
		HEADRGRP	'HG'
        
        set order to 1 
        set filter to           
Return Nil

*************************************************
*  ARTIKELLISTE - OHNE Lagerort, Sort nach HG-UG
*  
*------------------------------------------------
function ART_LIST_LAG0()
    select AART   
    set filter to LAGERRAUM = space(10) .OR. LAGER_REG=space(10)
    set order to 4      && index on HG+UG+upper(BEZK)          
    go top
	DO REPORT ;
		TITLE		'Artikel OHNE Lagerort | Sort: HG+UG'			;
		HEADERS		{'','','BED','','','',''} , {'HG','UG','ARF','Edvnr','BEZEICHNUNG','Raum','Regal'}	;
		FIELDS		{'HG','UG','BEDARF','Edvnr','BEZ1','LAGERRAUM','LAGER_REG'}				;
		WIDTHS		{2,2,4,7,35,8,10}							;
		TOTALS		{.F.,.F.,.F.,.F.,.F.,.F.,.F.}						;
		NFORMATS	{'','','9999','','','',''}					;
		WORKAREA	AART								;
		LPP		60								;
		CPL		80								;
		LMARGIN		3								;
		PAPERSIZE	DMPAPER_A4							;
		PREVIEW										; 
		SELECT										;
		MULTIPLE									;
		GROUPED BY	'HG'								;
		HEADRGRP	'HG'
		
        set filter to        
        set order to 1   
Return Nil
*************************************************
*  ARTIKELLISTE - PCK-INH > 1, ALIA 
*  
*------------------------------------------------
function REP_ALIA_1()
    *	NFORMATS	{'','','','999,999,999.99'}					;
    *	
    select ALIA  
    set order to 1     && index on  
    set filter to PACK_INH > 1
    go top
           
	DO REPORT ;
		TITLE		'ALIA-Stze die PACK-INH > 1 | Hinweisliste'			;
		HEADERS		{'','','',''} , {'EDVNR','LNR','BNR','PACK_INH'}	;
		FIELDS		{'EDVNR','LNR','BNR','PACK_INH'}				;
		WIDTHS		{9,6,20,5}							;
		TOTALS		{.F.,.F.,.F.,.F.}						;
		NFORMATS	{'','','','99999'}					;
		WORKAREA	ALIA								;
		LPP		60								;
		CPL		80								;
		LMARGIN		3								;
		PAPERSIZE	DMPAPER_A4							;
		PREVIEW										; 
		SELECT										;
		MULTIPLE

        
    set order to 1  
    set filter to 
    go top              									
Return Nil
